      SUBROUTINE CHECK(ATPR,ITPR,XYZ,NAT,NPRS,NPIEK,FAT,NFAT,R2)
      DIMENSION ATPR(6,NAT),ITPR(2,NAT),PRM(6),FAT(32,NFAT)
      DIMENSION XYZ(4,NPIEK),XS(3),X(4),XKEEP(3)
C
C  CHECK WHETHER ATOMS IN THE MODEL ARE REPRODUCED
C  IF OLD PEAKS ARE NOT REPRODUCED BY FOURIER THEY ARE DELETED
C  FROM THE MODEL, NPRS IS ADAPTED
C  REPRODUCED ATOMS ARE DELETED FROM THE LIST IN XYZ
C  NPC IS THE MAXIMUM NUMBER OF ATOMS ALLOWED IN THE NEW MODEL
C  NPIEK IS THE NUMBER OF PEAKS IN XYZ
C  NPIEK IS ADAPTED BECAUSE ONLY NEW ADDITIONS ARE
C  KEPT IN XYZ
C  NPRS IS THE NUMBER OF ATOMS IN THE MODEL ON ENTRY AND EXIT
C
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11),
     1 ISER(10),SF,SQ,DN,XN,MH(3),ITLE(20),DM,XM
      COMMON/PNTR/IPNT(10),JPNT(10),S(10),KPNT(10),NMO(10),KV(10)
     1 ,LPNT(10),ATOM(10),EXCL(10)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
	IFOUND=0
	IZOEK=INT(NPRS*1.1)
	DAV=0.0
      IF(NPRS.GT.0)THEN
      WRITE(LO,4)
    4 FORMAT(/,' CHECK: Input atoms of last fourier'//21X,'X',10X,'Y',
     1 10X,'Z',/)
      DO 5 J=1,NPRS
      WRITE(LO,6)(ATPR(I,J),I=1,3)
    5 CONTINUE
      ENDIF
6     FORMAT(14X,3F11.4,3X,F7.0)
      WRITE(LO,7)
    7 FORMAT(/,' Output obtained from last fourier'//21X,'X',10X,'Y',
     1 10X,'Z',7X,'Height',/)
      DO 8 J=1,NPIEK
      WRITE(LO,6)(XYZ(I,J),I=1,4)
    8 CONTINUE
	NPRSO=NPRS
      J=0
200	CONTINUE
	J=J+1
	IF(J.GT.NPRS)GOTO 1000
      L=0
	DMIN=10.0
      DO 201 II=1,3
  201 PRM(II)=ATPR(II,J)
1     CONTINUE
      L=L+1
      IF(L.GT.IZOEK)GO TO 210
      DO 11 I=1,4
11    X(I)=XYZ(I,L)
      DO 202 K=1,NQV
      DO 203 KK=1,3
      XS(KK)=PRM(1)*FS(1,KK,K)+PRM(2)*FS(2,KK,K)+
     1 PRM(3)*FS(3,KK,K)+TX(KK,K)
204   XD=X(KK)-XS(KK)
      IF(ABS(XD).LE.0.5)GOTO 203
      XS(KK)=XS(KK)+SIGN(1.0,XD)
      GO TO 204
  203 XS(KK)=XD
      CALL DSTNCE(XS,ORT,DST)
      IF(DST.LT.DMIN)THEN
	LMIN=L
	DMIN=DST
	DO 205 I=1,3
C	XKEEP(I)=X(I)-0.9*XS(I)
 	XKEEP(I)=X(I)-0.5*XS(I)
C     XKEEP(I)=X(I)
205	CONTINUE
      IHIGH=X(4)+0.5
	ENDIF
202	CONTINUE
	GOTO 1
210	CONTINUE
      IF(DMIN.LT.DN)THEN
	DO 211 I=1,3
211	ATPR(I,J)=XKEEP(I)
	ITPR(2,J)=IHIGH
	IFOUND=IFOUND+1
	DAV=DAV+SQRT(DMIN)
	CALL REMOVE(XYZ,ITPR,NPIEK,LMIN,4)
	IZOEK=IZOEK-1
	ELSE
	CALL REMOVE(ATPR,ITPR,NPRS,J,6)
	ENDIF
	GO TO 200
C
C  We have identified the peaks in XYZ which correspond to the atoms
C  in the model. Atoms not reproduced have been deleted.
C  New coordinates have been assigned, old atoms are deleted from XYZ
C  Now check the new peaks for inconsistencies with the model
C
1000  CONTINUE
	DAV=DAV/IFOUND
	Write(LO,*)'NUMBER, AVARAGE DIST ',IFOUND,DAV
      IF(NPRS.EQ.0)GOTO 996
      IF(NPRS.LT.NPRSO/3)GOTO 998
C     WRITE(LO,*)'NPC,NPRS,NPRSO ',NPC,NPRS,NPRSO
C     Do 306 J=1,NPRS
C     WRITE(LO,*)(ATPR(I,J),I=1,3)
C306   CONTINUE
      RETURN
  996 WRITE(LO,997)
997   FORMAT(/,' CHECK: Input model is probably completely incorrect'/
     1  ' AUTOFOUR fails')
      STOP 16
  998 WRITE(LO,999)
999   FORMAT(/,' CHECK: AUTOFOUR cannot extend this model'/
     1 ' try DIRDIF ?')
      STOP 16
      END
