      SUBROUTINE HEAVY2(IO,H,K,L,SN,FAT,NR,NFAT,ATPR,ITPR,NAT,NP,C,S,VC,
     1 DE,DIJ,N1,ETA,SF0,SF,FOBS,VER,ACALC,BCALC,WORK,NATS,IWORK)
C
C  CALCULATION OF ATOMIC NUMBERS
C
      REAL*8 DIJ,VC,DE
	DIMENSION FOBS(NR),VER(10,NR),ACALC(NR),BCALC(NR),WORK(NATS),
     1 IWORK(NAT)
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NQV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),MLAT,RS(3,3,24)
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/PNTR/IPNT(10),JPNT(10),Q(10),KPNT(10),NMO(10),KV(10)
     1  ,LPNT(10),ATOM(10),EXCL(10)
C
C  VAX ADAPTATION: FOR NAG ROUTINES REAL*8 VARIABLES, C(2*N1)
C
	INTEGER H,CC(1001)
      DIMENSION IO(NR),SN(NR),FAT(NFAT),ATPR(6,NAT),ITPR(2,NAT),
     1  S(N1),VC(N1),DE(N1),DIJ(N1,N1),H(NR),K(NR),L(NR),C(N1)
      REAL IO,IC
C
C  PRELIMINARY CALCULATIONS
C
	MINT=NATS/NAT
      DO 1 IH=1,NR
      F=IO(IH)
    1 IO(IH)=F*F
      SZO=0.
      SZ1=0.
C
C  SZO IS USED FOR THE RECALCULATION OF ETA
C  SZ1 IS USED FOR CONSTRAINING THE SET OF EQUATIONS
C
      DO 2 I=1,NAT
      Z=ATPR(6,I)
      OCC=ATPR(4,I)*NQV
      SZ1=SZ1+OCC*Z
    2 CONTINUE
      D=SF0/SZ1
      DO 5 I=1,NAT
      LV=ITPR(1,I)
      DO 24 IJ=1,NFAT
      IF(LV.EQ.KV(IJ))GOTO 245
24    CONTINUE
      ATPR(6,I)=ATPR(6,I)*D
245   SZO=SZO+ATPR(4,I)*ATPR(6,I)**2
5     CONTINUE
      ETA=ABS(1-SZO/SF)
      SZ1=SF0
C
C  WERKLOOP
C
      R2O=0.0
3     CONTINUE
	M=0
	DO 300 I=1,NAT
	M=M+1
	ITBL=ITPR(1,I)
	TF=FAT(ITBL)*ATPR(6,I)
	MTBL=IPNT(ITBL)
	IF(MTBL.EQ.0)MTBL=1
	IWORK(I)=MTBL
	WORK(M)=TF
	M=M+1
	WORK(M)=ATPR(4,I)
	DO 301 J=1,3
	M=M+1
	WORK(M)=ATPR(J,I)
301	CONTINUE
	DO 302 NS=2,NSYM
	X=0.0
	Y=0.0
	Z=0.0
	DO 303 II=1,3
      X=ATPR(II,I)*RS(1,II,NS)+X
      Y=ATPR(II,I)*RS(2,II,NS)+Y
      Z=ATPR(II,I)*RS(3,II,NS)+Z
303   CONTINUE
	M=M+1
      WORK(M)=X+TX(1,NS)
	M=M+1
      WORK(M)=Y+TX(2,NS)
	M=M+1
      WORK(M)=Z+TX(3,NS)
302	CONTINUE
300   CONTINUE
      R2=0.
      R2N=0.
C
C  INITIALIZE MATRIX AND VECTOR TO 0.
C
      DO 1234 I=1,N1
      VC(I)=0.0
      DO 2345 J=1,N1
      DIJ(I,J)=0.0
 2345 CONTINUE
 1234 CONTINUE
C
C  BUILD MATRIX AND VECTOR
C
      DO 6 IH=1,NR
      P=SN(IH)
      IF(P.LT.1.0E-6)GOTO 6
      LH=H(IH)
      LK=K(IH)
      LL=L(IH)
      LI=-LH-LK
C
C  CALCULATE INTENSITY REFLECTION LH,LK,LL
C
      CALL FCALC(A,B,P,LH,LK,LL,LI,WORK,IWORK,NATS,NAT,NAT,0,0,
     1 C,S,VER(1,IH),AF,BF)
      IC=A*A+B*B
      AIO=IO(IH)
      RES=AIO-IC
      R2=R2+RES*RES
      R2N=R2N+AIO*AIO
C
C  CALCULATE THE DERIVATIVE OF THIS REFLECTION
C  WITH RESPECT TO THE ATOMIC NUMBERS.
C
      CALL DE2(ITPR,NAT,DE,C,S,A,B,P)
      DO 4 J=1,NP
C
C  VC IS THE VECTOR OF RESIDUALS.
C
      VC(J)=VC(J)+RES*DE(J)
      DO 4 I=J,NP
C
C  DIJ IS THE MATRIX OF NORMAL EQUATIONS.
C  IT IS EASY TO SEE, THAT AT LEAST ONE CONSTRAINT SHOULD BE APPLIED.
C
    4 DIJ(I,J)=DIJ(I,J)+DE(I)*DE(J)
    6 CONTINUE
C
C  "INNER CORE" OF THE MATRIX IS NOW BUILT.
C  THE REST WILL BE FILLED USING THE SYMMETRY OF THIS PART.
C  THE OUTER RING OF THE MATRIX WILL BE USED FOR THE CONSTRAINTS.
C
      NM=NP-1
      DO 7 I=1,NM
      DIJ(N1,I)=1.
      DIJ(I,N1)=1.
      M=I+1
      DO 7 J=M,NP
    7 DIJ(I,J)=DIJ(J,I)
      DIJ(NP,N1)=1.
      DIJ(N1,NP)=1.
      VC(N1)=SF0-SZ1
C
C  MATRIX AND VECTOR ARE BUILT. NOW SOLVE SET OF EQUATIONS
C
      R2=R2/R2N
      WRITE(LO,110)NR,R2
110   FORMAT(/,' HEAVY2: R2 based on',I5,' low order reflections'/
     1  ' Before application of the calculated shifts R2 is: ',F6.4)
      CALL DSIFA(DIJ,N1,N1,CC,INFO)
      CALL DSISL(DIJ,N1,N1,CC,VC)
      SZ1=0.
      SZO=0.
99    FORMAT(/,' ',13X,'X',9X,'Y',9X,'Z',7X,'Change',4X,
     1 'New atomic number'/)
      J=0
      DO 8 I=1,NAT
      LVAST=ITPR(1,I)
      DO 244 IJ=1,10
      IF(LVAST.EQ.KV(IJ))GOTO 8
244   CONTINUE
	J=J+1
C
C  RESULT IN VC
C
      VC(J)=VC(J)*0.5
C
C  RESULT IN VC
C
C
100   FORMAT(' ',I5,5X,3(F7.4,3X),4X,F7.4)
8     CONTINUE
      WRITE(LO,99)
	R2O=R2
	SHIFT=1.0
12    J=0
	SZO=0.0
	SZ1=0.0
	M=1
      DO 9 I=1,NAT
	OCC=ATPR(4,I)*NQV
	Z=ATPR(6,I)
      LVAST=ITPR(1,I)
      DO 25 IJ=1,10
      IF(LVAST.EQ.KV(IJ))GOTO 49
25    CONTINUE
      J=J+1
C
C  RESULT IN VC
C
      DZ=VC(J)*SHIFT
	Z=Z+DZ
49	SZ1=SZ1+Z*OCC
	SZO=SZO+Z*Z*OCC*OCC
	ATPR(6,I)=Z
	WORK(M)=Z
	M=M+MINT
9     CONTINUE
	R2=0.0
	R2N=0.0
      DO 11 IH=1,NR
      P=SN(IH)
      IF(P.LT.1.0E-6)GOTO 11
      LH=H(IH)
      LK=K(IH)
      LL=L(IH)
      LI=-LH-LK
C
C  CALCULATE INTENSITY REFLECTION LH,LK,LL
C
      CALL FCALC(A,B,P,LH,LK,LL,LI,WORK,IWORK,NATS,NAT,NAT,0,0,
     1 C,S,VER(1,IH),AF,BF)
      IC=A*A+B*B
      AIO=IO(IH)
      RES=AIO-IC
      R2=R2+RES*RES
      R2N=R2N+AIO*AIO
11	CONTINUE
	R2=R2/R2N
	IF(R2O.LT.R2)THEN
	J=0
	DO 13 I=1,NAT
	Z=ATPR(6,I)
	OCC=ATPR(4,I)*NQV
	LVAST=ITPR(1,I)
	DO 26 IJ=1,10
	IF(LVAST.EQ.KV(IJ))GOTO 13
26	CONTINUE
	J=J+1
	DZ=VC(J)*SHIFT
	Z=Z-DZ
	ATPR(6,I)=Z
13	CONTINUE
	SHIFT=SHIFT/2.0
	IF(SHIFT.GT.0.1)GOTO 12
	ENDIF
      IF(ABS(R2O-R2)/R2.LT..05)GOTO 30
	DO 10 I=1,NAT
      WRITE(LO,100)I,(ATPR(II,I),II=1,3),ATPR(6,I)
10	CONTINUE
	ETO=ETA
	ETA=ABS(SZO/SF-1.0)
      GOTO 3
   30 CONTINUE
      DO 111 J=1,NR
111   IO(J)=SQRT(IO(J))
      WRITE(LO,120)
120   FORMAT(/,' Shifts are not applied, convergence was reached'/
     1 ' The final fourier is now calculated')
      RETURN
      END
