      SUBROUTINE POINTR(FAT,NFAT,FTT,JFAT)
C
C  SET UP ALTERNATIVE SCATTERING POWER NUMBERS
C  ELEMENTS DIFFERING LESS THAN THREE ELECTRONS ARE LUMPED TOGETHER
C
C  IPNT: LENGTH JFAT. CORRESPONDING TO I, THE INDEX TO FT(JFAT),
C        KPNT(IPNT(I)) CONTAINS THE INDEX TO FAT(32,NFAT) AFTER
C        SORTING ON Z.
C
C  KPNT: LENGTH NFAT, THE NUMBER OF TABLES PRESENT IN THE CRYSIN
C        FILE. CORRESPONDING TO I, THE TABLE NUMBER FROM THE CRYSIN
C        FILE, KPNT(I) CONTAINS THE POINTER TO THE ARRAY FAT(1,NFAT)
C        COPIED TO FT. FT IS SORTED ON Z.
C        ONLY POINTERS ARE PRESENT REFERRING TO TABLES WHICH ARE
C        ACTUALLY USED IN AUTOFOUR. THE ARRAY FAT IS SORTED ON Z
C
C  JPNT: LENGTH JFAT, JPNT(I) IS THE NUMBER OF ATOMS ASSIGNED TABLE
C        I IN AUTOFOUR
C
C  LPNT: LENGTH NFAT, CORRESPONDING TO I, THE TABLE NUMBER USED IN
C        THE CRYSIN FILE, LPNT(I) CONTAINS THE POINTER TO THE ARRAY
C        FT(JFAT).
C
C  S:    LENGTH JFAT, S(I) THE SCATTERING POWER
C        OF THE ATOMS USING TABLE I
C
C  ALL TABLE NUMBERS IN AUTOFOUR ARE SORTED ON SCATTERING POWER, THE
C  HEAVY ATOMS HAVE THE LOWER NUMBERS
C
      COMMON/UNIT/LRED,LO,LN,LM,LC,LSCRA,LSQ,LFILE,LPDB
      COMMON/SPEC/IFOUR1,IFOUR2,PERC,LTST,NCCH,DELR,STOPR,NUM(11)
     1 ,ISER(10),SF,SQ,DN,XN,DX,DY,DZ,ITLE(20),DM,XM
      COMMON/PNTR/IPNT(10),JPNT(10),S(10),KPNT(10),NMO(10),KV(10),
     1 LPNT(10),ATOM(10),EXCL(10)
      DIMENSION FAT(32,NFAT),KHULP(10),FTT(NFAT)
      INTEGER FT,FT1
      LOGICAL READY
      CALL SORTF(FAT,NUM,NFAT)
      DO 10 I=1,10
      KHULP(I)=0
10    JPNT(I)=0
      JFAT=0
      I=0
      FT1=100
	IF(NFAT.EQ.1)THEN
	CALL GETNUM(FAT,NFAT,JFAT,1,1,IP,KHULP)
	ELSE
1000  I=I+1
      IF(I.GT.NFAT)GOTO 2000
      FT=FAT(1,I)+0.5
      IF(FT.LE.1.10)GOTO 2000
      DO 1010 J=I+1,NFAT
      FT1=FAT(1,J)+0.5
      READY=FT-FT1.GT.2.0.OR.J.EQ.NFAT
      IF(READY)THEN
      CALL GETNUM(FAT,NFAT,JFAT,I,J,IP,KHULP)
      GO TO 1000
      ENDIF
1010  CONTINUE
      GOTO 1000
      ENDIF
2000  CONTINUE
      DO 2020 I=1,NFAT
      IPNT(I)=KPNT(I)
2020  KPNT(I)=KHULP(I)
	DO 7 JFT=1,JFAT
	DO 8 I=1,NFAT
	IF(LPNT(I).EQ.JFT)THEN
	IPNT(JFT)=I
	GOTO 7
	ENDIF
8	CONTINUE
7	CONTINUE
      DO 3 JFT=1,JFAT
      IFT=KPNT(IPNT(JFT))
	FTT(JFT)=FAT(1,IFT)
      S(JFT)=FAT(1,IFT)
	SS=S(JFT)
	E=1.25
	IF(SS.LE.12.0)E=1.55
	IF(SS.LE.10.0)E=0.85
	IF(SS.GT.18.0)E=1.60
      EXCL(JFT)=E
3     CONTINUE
	IF(NFAT.GT.JFAT)THEN
	DO 6 I=JFAT+1,NFAT
	IPNT(I)=0
6	CONTINUE
	ENDIF
      RETURN
      END
