C  *******************************************************************
C  Program:  conref80 (.f,.for,.fortran)
C  Version:  19/01/1996
C  Language: FORTRAN77
C  Purpose:  Reflection file conversion
C  *******************************************************************
C
C  For information, comments, suggestions, complaints, please contact:
C
C  Rene' de Gelder
C  Laboratorium voor Kristallografie
C  Katholieke Universiteit Nijmegen
C  Toernooiveld 1
C  6525 ED Nijmegen
C  Nederland
C
C  E-mail: U625018 at vm.uci.kun.nl
C  Tel:    080 - 652596
C  Fax:    080 - 553450
C
C  *******************************************************************
C
C  Last revision: RdG 19-01-1996: Read new type of .red file (MARC 993)
C  Last revision: RdG 03-03-1994: Output of FREFA-file (DIRDIF system)
C  CONREF80.FOR   Original 1-02-90, RDG
C  Formatted REDDIF-file (*.RDF) ---> Unformatted REDDIF-file (*.RED)
C
C  *******************************************************************
C
C  Omzetten van REDDIF-reflectie-file naar de oorspronkelijke
C  binaire vorm. Een dergelijke reflectie-file is het product van
C  de ouderwetse data-reductie zoals die plaatsvindt in Leiden.
C  Dit omzetten bestaat uit het terugveranderen van de geformateerde
C  REDDIF-file in de ongeformateerde versie. De geformateerde versie
C  kan worden gemaakt met FERNOC80. Dit is noodzakelijk om eventueel
C  een REDDIF-reflectie-file over te kunnen zenden naar elders.
C  Tijdens dit omzetten wordt nu ook een reflectie-file aangemaakt
C  die gebruikt kan worden voor het Nijmeegse DIRDIF systeem.
C
C  ******************************************************************
      PROGRAM CONREF
      IA=1
      IB=2
      IC=3
      WRITE(IC,10)
   10 FORMAT('FREFA  CCODE')
      CALL COPY(IA,IB,IC)
      WRITE(IC,20)
   20 FORMAT('E')
      STOP
      END
C
      SUBROUTINE COPY(IA,IB,IC)
C
C  MAAKT LETTERLIJKE COPIE VAN REFLECTIE DATASET:
C  IA IS INPUT, IB IS OUTPUT
C
      DIMENSION IH(3),W(20)
      CALL SPES(IA,IB,IC)
      ITEL=0
    1 READ(IA,110) MARC,IH,NGR
      READ(IA,120) W
      WRITE(IB) MARC,IH,NGR,W
      IF (MARC.NE.999) THEN
      WRITE(IC,130) IH(1),IH(2),IH(3),2*(NGR/2),W(1),W(8)
      ENDIF
  110 FORMAT(5I5)
  120 FORMAT(10F8.4)
  130 FORMAT(1X,3I3,I2,F9.4,F7.4)
      IF(MARC.EQ.999)RETURN
      GOTO 1
      END
C
      SUBROUTINE SPES(IA,IB,IC)
C
C  COPIEERT SPECIFIEKE GEGEVENS EN PRINT DEZE EVENTUEEL
C  INPUT = IA, OUTPUT = IB
C
      DIMENSION TI(20),CE(26),SY(24,3,4),FA(10,32),WR(10)
      DIMENSION FAB(10),ATGEW(10)     
      REAL LAB
      INTEGER HM
      CHARACTER NTYP(10)*4,SPAT*4
	SPAT="    "
      REWIND IA
      REWIND IB
      READ(IA,100)MARC
      READ(IA,200)TI
      WRITE(IB)MARC,TI
  100 FORMAT(I5)
  200 FORMAT(20A4)
      READ(IA,101)MARC,MRE,MSC,MCE,MSY,NFA
      READ(IA,201)CE
      WRITE(IB)MARC,MRE,MSC,MCE,MSY,NFA,CE
  101 FORMAT(6I5)
  201 FORMAT(8F10.5)
      DO 1 N=1,MSY
      READ(IA,102)MARC,((SY(N,I,J),J=1,4),I=1,3)
      WRITE(IB)MARC,((SY(N,I,J),J=1,4),I=1,3)
  102 FORMAT(I5,12F5.2)
    1 CONTINUE
      READ(IA,100)MARC
      BACKSPACE IA
      IF(MARC.EQ.993) THEN
      READ(IA,100)MARC
      READ(IA,1107)(NTYP(I),FAB(I),ATGEW(I),I=1,NFA)
      WRITE(IB)MARC,(NTYP(I),SPAT,FAB(I),ATGEW(I),I=1,NFA)
 1107 FORMAT(5X,A4,2F12.6)
      ENDIF
      READ(IA,103)MARC,HM,KM,LM,XLAB
      WRITE(IB)MARC,HM,KM,LM,XLAB
  103 FORMAT(4I5,F10.5)
      DO 2 N=1,NFA
      READ(IA,104)MARC
      READ(IA,204)(FA(N,I),I=1,32)
      WRITE(IB)MARC,(FA(N,I),I=1,32)
  104 FORMAT(I5)
  204 FORMAT(8F10.5)
    2 CONTINUE
      READ(IA,105)MARC,NGR
      WRITE(IB)MARC,NGR
  105 FORMAT(2I5)
      READ(IA,106)MARC,FOOO
      READ(IA,206)(WR(N),N=1,10)
      WRITE(IB)MARC,FOOO,(WR(N),N=1,10)
  106 FORMAT(I5,F10.2)
  206 FORMAT(8F10.5)
      RETURN
      END
