      SUBROUTINE ADDPI(A,B,F,IA)
C  *******************************************************************
C  Program:  deter (.f,.for,.fortran)
C  Version:  Summer 1998
C  Language: FORTRAN77
C  Purpose:  solving the phase problem in single-crystal x-ray
C            diffraction
C  *******************************************************************
C
C  For information, comments, suggestions, complaints, please contact:
C
C  RAG de Graaff
C  Leiden Institute of Chemistry
C  Gorlaeus Laboratories
C  University of Leiden
C  PO Box 9502
C 2300 RA Leiden, The Netherlands
C
C  E-mail: rag@chemb0b.leidenuniv.nl
C  Tel:    +31 +71 5274414
C
C  *******************************************************************
C Extensive revision Rag May, June '95: Reads formatted structure factor
C       file 25, file may contain phases and weights. Phases may be
C       refined or not. Downwards compatible. Results may differ from
C       earlier versions as reflections used to construct top row are
C       now taken from files 15 or 25, not 9 anymore. NSTR reflections
C       - input - are used here. Threshold Emin=1.2 now in LESTR.
C  Last Revision: RAG Summer 1998
C  Uses largest eigenvalue in phase refinement. However, the old
C  refinement is supported still. Construction of matrices > N
C  Phase refinement based on minimizing negative eigenvalues
C  See: van der Plas et al, Acta Cryst A, 1998
C  Lots of dead code removed
C
C***********************************************************************
C  ADDPI: ADD PI TO PHASES IN LOWER LARGE TRIANGLE OF INPUT MATRIX
C***********************************************************************
C  LAST EDIT: 27-09-90
C***********************************************************************
      DIMENSION A(IA,IA),B(IA,IA)
      PI=3.14159265
      DO 10 I=2,IA
      DO 20 J=1,I-1
      X=A(I,J)
      Y=B(I,J)+PI
      SX=SIN(X)
      CX=COS(X)
      SY=SIN(Y)
      CY=COS(Y)
      A(I,J)=ATAN2(SX*F+(1-F)*SY,CX*F+(1-F)*CY)
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
