      SUBROUTINE CHINV(A,B,P,C,D,Q,M,N,INV)
C
C  CHINV CALCULATES FROM A(N,N),B(N,N),P(N)-OBTAINED BY CALLING CHOLH
C  FIRST- THE MATRICES C(N,N),D(N,N),Q(N)
C  AFTER CALLING CHINV THE LARGE LOWER TRIANGLES OF C AND D
C  CONTAIN THE INVERSE OF THE UPPER TRIANGLES OF A,B
C  THE UPPER TRIANGLES OF C AND D CONTAIN THE TRANSPOSE OF THE
C  INVERSE OF THE LARGE LOWER TRIANGLES OF A,B (DIAGONAL IN Q)
C  A AND B ARE UNCHANGED ON EXIT
C  THE CALCULATION IS PERFORMED FROM ROW M TO N(INCLUDING N)
C  IF M>1 THE RESULTS FOR ROWS 1-(M-1) MUST BE KNOWN
C  THE M-1 ROWS AND COLUMNS OF THE LOWER TRIANGLES ARE UNCHANGED
C  THE PARAMETER INV :
C  INV=0 THE PRODUCT OF THE LOWER TRIANGLES OF C,D ARE NOT PUT INTO
C  THE UPPER TRIANGLES AND Q
C  INV=2  THE INVERSE IS PUT INTO THE UPPER TRIANGLES
C  NOTE IF M#1 CHINV MAY ONLY BE CALLED ONCE WITH N=M-1
C  OTHERWISE NONSENSE WILL RESULT
C  INV=1 ONLY THE COLUMNS M THROUGH N ARE FILLED
C  THE COLUMNS 1 THROUGH M-1 ARE NOT THE INVERSE
C
      DIMENSION A(N,N),B(N,N),C(N,N),D(N,N),P(N),Q(N)
	MI=MAX0(2,M)
      IF(M.NE.1) GOTO 10
      Q(1)=0.0
      D(1,1)=0.0
      C(1,1)=1.0/P(1)
      IF(N.EQ.1) GOTO 1000
   10 CONTINUE
      DO 100 I=MI,N
      CII=1.0/P(I)
      C(I,I)=CII
      D(I,I)=0.0
      J=I
      DO 100 JJ=2,I
      J=J-1
      X=0.0
      Y=0.0
      KMAX=I-1
      DO 50 K=J,KMAX
      AKI=A(K,I)
      CKJ=C(K,J)
      BKI=B(K,I)
      DKJ=D(K,J)
      X=X+AKI*CKJ-BKI*DKJ
   50 Y=Y+AKI*DKJ+BKI*CKJ
      C(I,J)=-X*CII
  100 D(I,J)=-Y*CII
 1000 IF(INV.EQ.0) GOTO 9999
      DO 1010 I=MI,N
      Q(I)=0.0
      JMAX=I-1
      DO 1010 J=1,JMAX
      C(J,I)=0.0
 1010 D(J,I)=0.0
      MI=1
      IF(INV.EQ.1) MI=M
      DO 1100 I=MI,N
      DO 1100 J=1,I
      X=0.0
      Y=0.0
      KMIN=MAX0(I,M)
      DO 1050 K=KMIN,N
      CKI=C(K,I)
      CKJ=C(K,J)
      DKI=D(K,I)
      DKJ=D(K,J)
      X=X+CKI*CKJ+DKI*DKJ
 1050 Y=Y+CKI*DKJ-DKI*CKJ
      IF(I.EQ.J) GOTO 1060
      C(J,I)=C(J,I)+X
      D(J,I)=D(J,I)+Y
      GOTO 1100
 1060 Q(I)=Q(I)+X
 1100 CONTINUE
 9999 RETURN
      END
