      SUBROUTINE CHOLH(A,B,P,M,N,IFAIL)
C
C  FACTORISATION OF A POSITIVE DEFINITE HERMITIAN MATRIX
C  A(IA,N) IS REAL, B(IB,N) IS IMAGINARY
C  ONLY THE LOWER TRIANGLES OF A AND B NEED BE SUPPLIED
C  THE UPPER TRIANGLES CONTAIN THE TRIANGULAR MATRICES
C  P(N) IS THE DIAGONAL OF THE REAL PART
C  A,B AND P MUST BE ALREADY FACTORIZED TO ORDER M-1
C  THE LOWER TRIANGLES ARE UNCHANGED ON EXIT
C  IFAIL SHOULD BE ZERO ON EXIT
C  IFAIL=N DENOTES THE NUMBER OF THE FIRST NEGATIVE DIAGONAL ELEMENT
C
      DIMENSION A(N,N),B(N,N),P(N)
      IFAIL=0
      DO 80 I=1,N
      MI=MAX0(I,M)
      DO 80 J=MI,N
      X=A(J,I)
      Y=B(J,I)
      IF(I.EQ.1)GOTO 20
      II=I-1
      DO 10 K=1,II
      AKJ=A(K,J)
      AKI=A(K,I)
      BKJ=B(K,J)
      BKI=B(K,I)
      X=X-AKJ*AKI-BKJ*BKI
   10 Y=Y+AKJ*BKI-BKJ*AKI
   20 IF(I.EQ.J)GOTO 30
      PI=1.0/P(I)
      A(I,J)=X*PI
      B(I,J)=Y*PI
      GOTO 80
   30 IF(X.GT.0.0) GOTO 40
      IFAIL=I
      RETURN
   40 P(I)=SQRT(X)
   80 CONTINUE
      RETURN
      END
