      SUBROUTINE DET1(NNRM,NM,EMX,PMX,AMX,BMX,
     1 DAMX,IJP,NIJP,IJQ,NIJQ,FAS,F,FDET,IFAIL)
C
C  CALCULATES DETA OR THE PRODUCT OF THE SUBDETERMINANTS AS A
C  FUNCTION OF THE INDEPENDENT VARIABLES IN FAS.
C  NNRM: NUMBER OF SUBDETERMINANTS = INPUT
C  NM: ORDER OF ANY DETERMINANT = INPUT
C  EMX(NM,NM,NNRM) MODULI OF THE MATRIX ELEMENTS = INPUT
C  PMX(NM,NM,NNRM) PHASES OF THE MATRIX ELEMENTS IN RADIANS
C  AMX(NM,NM,NNRM) =INPUT
C  = OUTPUT CHOLH
C  BMX(NM,NM,NNRM) AS AMX BUT IMAGINARY
C  DAMX(NM,NNRM) DIAGONAL OF AMX
C  IJP(NIJP) =INPUT, SEE SUBR MMTRX
C  FAS(NIJP) =INPUT, THE INDEPENDENT PHASES
C  FDET(NNRM) =OUTPUT, INDIVIDUAL DETERMINANT VALUES
C  IFAIL: SEE CHOLH
C
      DIMENSION EMX(NM,NM,NNRM)
      DIMENSION PMX(NM,NM,NNRM)
      DIMENSION AMX(NM,NM,NNRM)
      DIMENSION BMX(NM,NM,NNRM)
      DIMENSION DAMX(NM,NNRM)
      DIMENSION FDET(NNRM)
      DIMENSION IJP(7,NIJP),IJQ(8,NIJQ)
      DIMENSION FAS(NIJP)
C
C  STORE INPUT PHASES IN THE MATRICES
C
      IF(NIJP.GT.0)
     1 CALL VULLER(NNRM,PMX,NM,IJP,NIJP,IJQ,NIJQ,FAS)
C
C  TRANSFORM FROM MODULES AND PHASES TO REAL AND IMAGINARY
C
      DO 100 MA=1,NNRM
      DO 80 I=1,NM
      JMAX=I-1
      AMX(I,I,MA)=EMX(I,I,MA)
      BMX(I,I,MA)=0.0
      IF(JMAX.LT.1) GOTO 80
      DO 50 J=1,JMAX
      AMX(I,J,MA)=EMX(I,J,MA)*COS(PMX(I,J,MA))
      BMX(I,J,MA)=EMX(I,J,MA)*SIN(PMX(I,J,MA))
   50 CONTINUE
   80 CONTINUE
  100 CONTINUE
C
C  CHOLESKY DECOMPOSITION
C
      F=1.0
      DO 150 MA=1,NNRM
      FM=1.0
      CALL CHOLH(AMX(1,1,MA),BMX(1,1,MA),DAMX(1,MA),1,NM,IFAIL)
      IF(IFAIL.NE.0) THEN
      IFAIL=MA
      F=0.0
      GOTO 999
      ELSE
      DO 190 I=1,NM
      FM=FM*DAMX(I,MA)
  190 CONTINUE
      FM=FM*FM
      FDET(MA)=FM
C
C  INSTEAD OF THE PRODUCT THE GEOMETRIC MEAN IS TAKEN
C  OF THE INDIVIDUAL SUBDETERMINANTS
C  THIS IS THE SAME AS THE N-TH ROOT OF THE PRODUCT
C
      F=F*(FM/F)**(1.0/FLOAT(MA))
      ENDIF
  150 CONTINUE
  999 CONTINUE
      RETURN
      END
