      SUBROUTINE EXPA(A,NN,NREF,W,NWMAX,KHL,NK,NTOT)
C
C  EXPAND DATA INTO COMPLETE SPHERE, DUMP ON ISCRA
C  CODED REFLEXIONS IN A ARE TRANSFORMED TO STANDARD FORM (MULTAN)
C  PARENT H,K,L + 128 PACKED IN A(5,*)
C  TYPE IN A(4,*)
C  PHASESHIFT IN A(3,*) AND SIGN IN A(2,*)
C  LAST REFLEXION IS DUMMY, TOTAL NUMBER IS NTOT
C  HMAX, KMAX, LMAX ARE INITIALIZED
C  STMAX IS EQUAL TO MAX(1/D**2) VALUE ON EXIT
C
      INTEGER HMAX
      INTEGER A(NN,NREF)
      INTEGER W(2,NWMAX)
      DIMENSION KHL(6,1)
      DIMENSION Q(6)
      COMMON /COMHAS/ IHAS,NHAS
      COMMON /UNIT/ LN,LO,ISTAN,ISCRA,LNTA,IFMLTN,IFDET
      COMMON /PACK/ LK1,LK2,LK3,IP1,IP2,IP3,IP4
      COMMON /SYMTRY/ IS(2,3,24),TS(3,24),NSYM,LATT,ICENT,NORI
      COMMON /TITLE/ ITLE(20)
      COMMON /PARAM/ PARA(6)
      COMMON /CONST/ CED,HMAX,KMAX,LMAX,STMAX,JN(8),JZ(8)
	EXTERNAL UNPACK
      IF(NWMAX.LT.1) GOTO 1000
      IF(NK.LT.NN*NSYM) GOTO 1000
      STMAX=0.0
      HMAX=0
      KMAX=0
      LMAX=0
      NW=0
      NTOT=0
C
C  CALCULATE Q-VALUES
C
      CALL CELL(PARA,Q,VOLUME,1)
      DO 500 IR=1,NREF
C
C  UPDATE STMAX
C
      CALL UNPK1(A(5,IR),LH,LK,LL)
      ST=LH*LH*Q(1)+LK*LK*Q(2)+LL*LL*Q(3)
     1 +LH*LK*Q(4)+LK*LL*Q(5)+LL*LH*Q(6)
      STMAX=AMAX1(ST,STMAX)
C
C  GENERATE SYMMETRY EQUIVALENTS AND PHASESHIFTS
C
      CALL EXP1(A(5,IR),KHL)
      DO 450 J=1,NSYM
      IF(KHL(6,J).EQ.0) GOTO 420
      CALL UNPACK(KHL(6,J),LH,LK,LL)
      IF(HMAX.LT.IABS(LH)) HMAX=IABS(LH)
      IF(KMAX.LT.IABS(LK)) KMAX=IABS(LK)
      IF(LMAX.LT.IABS(LL)) LMAX=IABS(LL)
C
C  STORE ONE REFLEXION, DUMP BLOCK IF NECESSARY
C
      IT=0
      IF(KHL(5,J).EQ.-1) IT=1
      CALL STR1(LH,LK,LL,IR,KHL(4,J),IT,W,NWMAX,NW,ISCRA)
      NTOT=NTOT+1
C
C  STORE FRIEDEL REFLEXION
C
      CALL STR1(-LH,-LK,-LL,IR,MOD(24-KHL(4,J),24),1-IT,W,
     1 NWMAX,NW,ISCRA)
      NTOT=NTOT+1
  420 CONTINUE
  450 CONTINUE
  500 CONTINUE
C
C  PUT LAST RECORD
C
      CALL STR1(0,0,0,0,0,0,W,NWMAX,NW,ISCRA)
      GOTO 2000
 1000 WRITE(LO,1) NWMAX,NK
    1 FORMAT(//,' DIMENSION ERROR IN EXPA: NWMAX=,NK=',2I10)
      STOP
 2000 CONTINUE
      WRITE(LO,2) NTOT,HMAX,KMAX,LMAX,STMAX
    2 FORMAT(/,' NUMBER OF SYMMETRY DEPENDENT REFLEXIONS:',I6,/,
     1 6H HMAX=,I5,6H KMAX=,I5,6H LMAX=,I5,
     2 ' 1/D**2 MAX=',F10.6)
      RETURN
      END
