      SUBROUTINE JAAP1(AMX,BMX,DAMX,CMX,DMX,DCMX,IJP,NIJP,
     1 IJQ,NIJQ,NNRM,NM,GC,FDET)
C
C  CALCULATES DBETA/DALPHA (SEE PAPER)
C  CHOLH MUST HAVE BEEN CALLED
C  THE MATRICES CMX,DMX AND DIAG CONTAIN THE INVERSE
C  OF THE KH MATRICES (SEE CHINV)
C  GC CONTAINS THE GRADIENTS
C
      DIMENSION AMX(NM,NM,NNRM)
      DIMENSION BMX(NM,NM,NNRM)
      DIMENSION DAMX(NM,NNRM)
      DIMENSION CMX(NM,NM,NNRM)
      DIMENSION DMX(NM,NM,NNRM)
      DIMENSION DCMX(NM,NNRM)
      DIMENSION FDET(NNRM)
      DIMENSION IJP(7,NIJP)
      DIMENSION IJQ(8,NIJQ)
      DIMENSION GC(NIJP)
C
C  INVERT THE MATRICES
C
      DO 50 MA=1,NNRM
      CALL CHINV(AMX(1,1,MA),BMX(1,1,MA),DAMX(1,MA),
     1 CMX(1,1,MA),DMX(1,1,MA),DCMX(1,MA),
     2 1,NM,1)
   50 CONTINUE
      DO 100 I=1,NIJP
C
C  GET ROW AND COLUMN OF VARIABLE I
C
C     WRITE(6,*)(IJP(KK,I),KK=1,7)
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IMA=IJP(3,I)
C
C  GET PHASE AND MODULUS
C
      AIJ=AMX(IRY,IKO,IMA)
      BIJ=BMX(IRY,IKO,IMA)
      CIJ=CMX(IKO,IRY,IMA)
      DIJ=DMX(IKO,IRY,IMA)
      AABS=SQRT(AIJ**2+BIJ**2)
      ALPHA=0.0
      IF(AABS.NE.0.0) ALPHA=ATAN2(BIJ,AIJ)
      BABS=SQRT(CIJ**2+DIJ**2)
      BETA=0.0
      IF(BABS.NE.0.0) BETA=ATAN2(DIJ,CIJ)
      GC(I)=-2.0*AABS*BABS*SIN(ALPHA-BETA)*FDET(IMA)
C
C  GET SYMMETRY DEPENDENTS CONTRIBUTING IF ANY
C
      IEI=IJP(5,I)
      IF(IEI.NE.0)THEN
      IBE=IJP(4,I)
      DO 90 J=IBE,IEI
C     WRite(6,*)(IJQ(kkk,J),KKK=1,8)
      IRY=IJQ(1,J)
      IKO=IJQ(2,J)
      IMA=IJQ(3,J)
      AIJ=AMX(IRY,IKO,IMA)
      BIJ=BMX(IRY,IKO,IMA)
      CIJ=CMX(IKO,IRY,IMA)
      DIJ=DMX(IKO,IRY,IMA)
      AABS=SQRT(AIJ**2+BIJ**2)
      ALPHA=0.0
      IF(AABS.NE.0.0) ALPHA=ATAN2(BIJ,AIJ)
      BABS=SQRT(CIJ**2+DIJ**2)
      BETA=0.0
      IF(BABS.NE.0.0) BETA=ATAN2(DIJ,CIJ)
C
C  ADD SYMMETRY DEPENDENTS CONTRIBUTION WITH CORRECT SIGN
C
      IT=IJQ(8,J)
      GC(I)=GC(I)-2.0*AABS*BABS*SIN(ALPHA-BETA)*(1-2*IT)*FDET(IMA)
   90 CONTINUE
      ENDIF
C     GC(I)=GC(I)*FDET/NNRM
C     Write(6,*)'Ik heb de gradient: ',GC(I)
  100 CONTINUE
      RETURN
      END
