      SUBROUTINE MSIG2(PMX,NM,EMX,NNMR,IJP,NIJP,IJQ,NIJQ)
C
C  USING THE KNOWN PHASES THIS ROUTINE CALCULATES THE UNKNOWNS IN THE
C  LOWER TRIANGLE OF PMX
C  IJQ SHOULD BE INITIALIZED
C
      DIMENSION PMX(NM,NM,NNMR)
      DIMENSION EMX(NM,NM,NNMR)
      DIMENSION IJP(7,NIJP),IJQ(8,NIJQ)
      TWOPI=8.0*ATAN(1.0)
      PID12=TWOPI/24.0
      PID2=6.*PID12
      THPID2=3*PID2
  100 CONTINUE
C
C  IC=1: NEW PHASE FOUND
C
      IC=0
      DO 200 L=1,NIJP
      I=IJP(1,L)
      J=IJP(2,L)
      MA=IJP(3,L)
      IBE=IJP(4,L)
      IEI=IJP(5,L)
      MK=IJP(6,L)
      IS=0
      IT=0
C
C  PHASE ALREADY KNOWN
C
      IF(PMX(I,J,MA).LE.1.000001*TWOPI) GOTO 200
      SINP=0
      COSP=0
  185 CONTINUE
      KMAX=NM
      DO 180 K=1,KMAX
C
C  IGNORE MAIN DIAGONAL
C
      IF(K.EQ.I) GOTO 180
      IF(K.EQ.J) GOTO 180
C
C  CALCULATE LOWER TRIANGLE ONLY
C
      IF(K.GT.I) GOTO 110
      I1=I
      K1=K
      V1=1.0
      GOTO 120
C
C  EXCHANGE ROWS AND COLUMNS, STORE CHANGE
C
  110 I1=K
      K1=I
      V1=-1.0
C
C  PHASE KNOWN?
C
  120 IF(PMX(I1,K1,MA).GT.TWOPI) GOTO 180
C
C  LOWER TRIANGLE ONLY
C
      IF(K.LT.J) GOTO 130
      J2=J
      K2=K
      V2=1.0
      GOTO 140
C
C  EXCHANGE ROW AND COLUMN, STORE CHANGE IN V2
C
  130 J2=K
      K2=J
      V2=-1.0
C
C  PHASE UNKNOWN?
C
  140 IF(PMX(K2,J2,MA).GT.TWOPI) GOTO 180
C
C  APPLY SIGMA2
C
      E3=EMX(I,J,MA)*EMX(I1,K1,MA)*EMX(K2,J2,MA)
      PIJ=(V1*PMX(I1,K1,MA)+V2*PMX(K2,J2,MA))*(1-2*IT)-IS*PID12
      SINP=SINP+SIN(PIJ)*E3
      COSP=COSP+COS(PIJ)*E3
  180 CONTINUE
      IF(IEI.EQ.0)GO TO 195
      DO 191 II=IBE,IEI
      MI=IJQ(3,II)
      IF(MI.LE.MA)GO TO 191
      MA=MI
      I=IJQ(1,II)
      J=IJQ(2,II)
      IS=IJQ(7,II)
      IT=IJQ(8,II)
      GO TO 185
  191 CONTINUE
  195 CONTINUE
      I=IJP(1,L)
      J=IJP(2,L)
      MA=IJP(3,L)
      IF(ABS(COSP)+ABS(SINP).LT.1.0E-1) GOTO 200
      PMX(I,J,MA)=ATAN2(SINP,COSP)
      IC=1
      IF(MK.EQ.1)GO TO 190
      Z=PMX(I,J,MA)
      Y=(MK-1)*PID12
      X=AMOD(Z-Y,TWOPI)
      IF(X.LT.0.0)X=X+TWOPI
      IF(X.GT.PID2.AND.X.LT.THPID2)Y=Y+TWOPI/2
      PMX(I,J,MA)=Y
  190 CONTINUE
      IF(PMX(I,J,MA).LT.0.0) PMX(I,J,MA)=PMX(I,J,MA)+TWOPI
      IF(IEI.EQ.0) GOTO 200
      DO 170 II=IBE,IEI
      I1=IJQ(1,II)
      J1=IJQ(2,II)
      IS=IJQ(7,II)
      IT=IJQ(8,II)
      M1=IJQ(3,II)
      Z=AMOD(PMX(I,J,MA)*(1-2*IT)+IS*PID12,TWOPI)
      IF(Z.LT.0.0)Z=Z+TWOPI
      PMX(I1,J1,M1)=Z
  170 CONTINUE
  200 CONTINUE
C
C  NEW PHASE FOUND, THEN TRY AGAIN
C
      IF(IC.EQ.1) GOTO 100
  900 RETURN
      END
