      SUBROUTINE TEOFS(X,NATOM,PMX,MX,NM,NNRM,IJP,NIJP,IJQ,
     1 NIJQ,IN,LO, IS,TS,NSYM)
C
C  PUTS CALCULATED PHASES IN PMX
C  READS NATOM ATOMS OF FILE "IN" IN FREE FORMAT
C  ATOP: MULTIPLICITY*ATOMNUMBER, X, Y, Z
C  X: WORKSPACE
C  NATOM: NUMBER OF ATOMS
C
      INTEGER H(3)
      INTEGER HKL
      DIMENSION X(4,NATOM),PMX(NM,NM,NNRM),
     1 MX(NM,NNRM),IJP(7,NIJP),IS(2,3,NSYM),TS(3,NSYM),IJQ(8,NIJQ)
      M128=8421504
      TWOPI=2*355./113.
C
C  READ ATOMPARAMETERS
C
      NTOM=1
  500 READ(IN,*,END=1000) X(1,NTOM),X(2,NTOM),X(3,NTOM),X(4,NTOM)
      NTOM=NTOM+1
      IF(NTOM.GT.NATOM) GOTO 1000
      GOTO 500
 1000 CONTINUE
      NTOM=NTOM-1
      NATOM=NTOM
      WRITE(LO,1) NATOM
    1 FORMAT(' NUMBER OF ATOMS:',I5)
      WRITE(LO,2)
    2 FORMAT(1H ,3('NR*MULT  X      Y      Z  '),/)
      WRITE(LO,3) X
    3 FORMAT(3(1X,F4.1,3F7.3))
C
C  LOOP OVER INDEPENDENT PHASES
      DO 100 I=1,NIJP
C
C  GET HKL
C
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IMA=IJP(3,I)
      HKL=M128+MX(IKO,IMA)-MX(IRY,IMA)
      CALL UNPK1(HKL,H(1),H(2),H(3))
C
C  A=REAL, B=IMAGINARY
C
      A=0.0
      B=0.0
C
C  LOOP OVER ATOMS
C
      DO 90 J=1,NATOM
C
C  LOOP OVER SYMMETRY OPERATIONS
C
      DO 80 K=1,NSYM
      ARG=0.0
      DO 70 L=1,3
      XX=0.0
      DO 60 LL=1,2
      M=IABS(IS(LL,L,K))
      IF(M.NE.0) XX=XX+X(1+M,J)*ISIGN(1,IS(LL,L,K))+TS(L,K)
   60 CONTINUE
      ARG=ARG+H(L)*XX
   70 CONTINUE
      ARG=TWOPI*ARG
      A=A+X(1,J)*COS(ARG)
      B=B+X(1,J)*SIN(ARG)
   80 CONTINUE
   90 CONTINUE
C
      W=0.0
      IF(A.NE.0.0.OR.B.NE.0.0) W=ATAN2(B,A)
      W=AMOD(W,TWOPI)
      PMX(IRY,IKO,IMA)=W
  100 CONTINUE
C
C  IMPLEMENT SYMMETRY RELATIONS
C
      CALL VERBA(NNRM,PMX,NM,IJQ,NIJQ)
      RETURN
      END
