C**** * * * * * * * * * * * * * * * * NORMAL * * * * * * * * * 82/11/03*00010011
C****    PROGRAM FOR THE CALCULATION OF NORMALISED STRUCTURE FACTORS    00020001
C**** VERSION    JAN    1980                          UNIVERSITY OF YORK00030001
C  SCATTERING FACTORS TABLES HAVE BEEN CHANGED
C  DO NOT USE THIS PROGRAM AS STAND ALONE NORMALIZING TOOL
C  GET THE ORIGINAL FROM THE AUTHORS
C
C**** ------------------------------------------------------------------00040001
C**** INPUT/OUTPUT UNITS, TITLE, FLAGS                                  00050001
C**** EXTERNAL PGMASK,FNTH,TRCH,ANDORX                                  00060002
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    00070000
C**** SYMMETRY                                                          00080001
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT,LATB      00090000
C**** SCRATCH TAPE REFLEXION ARRAYS                                     00100001
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       00110000
     1 RHO(60),SIG(60)                                                  00120000
C**** ATOMIC SCATTERING FACTORS                                         00130001
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
C**** KNOWN MOLECULAR (GROUP) INFORMATION                               00150001
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           00160000
C**** SPHERICAL SCATTERING FACTORS                                      00170001
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF                             00180000
C**** MISCELLANEOUS                                                     00190001
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        00200000
C**** WILSON PLOT PARAMETERS                                            00210001
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS00220000
C**** STATISTICAL CHARTS                                                00230001
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL      00240000
C**** REFLEXION DATA FOR MULTAN                                         00250001
      COMMON/XXX/IX(1000),EX(1000),FX(1000)                             00260000
C**** SIN/COS TABLE                                                     00270001
      COMMON/TRIG/SINT(450)                                             00280000
C**** NULLIFY ARRAYS AND SOME VARIABELS                                 00290007
      ISC=0                                                             00300007
      DO 10 I=1,10                                                      00310005
      NINF(I)=0                                                         00320005
   10 CONTINUE                                                          00330005
C**** WRITE PROGRAM HEADER                                              00340006
      WRITE(6,4000)                                                     00350000
 4000 FORMAT('1',30X,                                                   00360011
     *'***  N O R M A L 8 0    PROGRAMMA VOOR E-BEREKENING    ***'//,   00370011
     *37X,'AUTEUR     : PETER MAIN ET AL. YORK,UNIT. KINGD.'//,         00380011
     *37X,'DATUM      : 2 NOVEMBER 1982 '//,                            00390011
     *37X,'INFORMATIE : S.GORTER'//,                                    00400011
     *' ',33('****'),//)                                                00410011
C**** DEFINE INPUT AND OUTPUT CHANNELS                                  00420006
C**** CARD READER                                                       00430001
      LN=1                                                              00440000
C**** LINE PRINTER                                                      00460001
      LO=6                                                              00470000
C**** INPUT OF BINARY REFLEXION DATA
C**** OUTPUT GAAT NAAR KANAAL 15 I.V.M MICROVAX
      ISTAN=20                                                          00490007
C**** SCRATCH TAPE                                                      00500001
      ISCRA=8                                                           00510000
C**** OUTPUT FOR MULTAN (FORMATTED)                                     00520001
      LNTA=9                                                            00530000
C**** MULTAN RECYCLE INSTRUCTIONS                                       00540001
      LREC=12                                                           00550000
C**** FOURIER OUTPUT FILE FOR INPUT TO EXFFT (MAY EQUAL ISCRA)          00560001
      LFOUR=10                                                          00570000
C**** SET UP INITIAL VALUES, READ PROGRAM PARAMETERS                    00580001
      PI=4.0*ATAN(1.0)                                                  00590000
      NREF=0                                                            00600000
      RHOMAX=0.0                                                        00610000
      DTOR=PI/180.0                                                     00620000
C**** SET UP SIN/COS TABLE                                              00630001
      DO 50 I=1,450                                                     00640000
      SINT(I)=SIN(DTOR*FLOAT(I-1))                                      00650000
   50 CONTINUE                                                          00660000
      READ(LN,100)ITLE                                                  00670000
  100 FORMAT(20A4)                                                      00680000
      WRITE(LO,120) ITLE                                                00690000
  120 FORMAT(39H0PROGRAM TO NORMALISE STRUCTURE FACTORS,60X,            00700000
     1 21HVERSION    JAN   1980/1H0,20X,20A4)                           00710000
      CALL TRANSL(JUMP,BT)                                              00720000
      ANAT=FLOAT(NAT)/(PTS*FLOAT((ICENT+1)*NSYM))                       00730000
      WRITE(LO,370) ANAT                                                00740000
  370 FORMAT(1H0,39X,36HNUMBER OF ATOMS IN ASYMMETRIC UNIT =,F6.2)      00750000
      NASU=INT(ANAT+0.5)                                                00760000
C**** CALCULATE NUMBER OF REFLEXIONS TO PASS TO MULTAN                  00770001
      IF (MM.GT.0) GOTO 400                                             00780000
      MN = INT(4.0*ANAT+100.5)                                          00790000
      IF (ICENT.EQ.1) MN = MN + 50                                      00800000
      IF (NSYM.EQ.1) MN = MN + 50                                       00810000
      MN = MIN0(MN,500)                                                 00820000
      MM=MN+MIN0(500-MN,100)/2                                          00830000
C**** CHECK IF WEIGHTED OR DIFFERENCE FOURIER IS REQUIRED               00840001
  400 NDIFF=0                                                           00850000
      NGP1=NGP                                                          00860004
      IF(NGP1.EQ.0)NGP1=1                                               00870004
      DO 410 I=1,NGP1                                                   00880004
      IF(NINF(I).GT.5) GO TO 420                                        00890000
  410 CONTINUE                                                          00900000
      IF(MM.GT.0) WRITE(LO,380) MM,MZ                                   00910000
  380 FORMAT(1H0,27X,22HOUTPUT FOR MULTAN  -  ,I5,13H  LARGEST E'S,3X,  00920000
     1 3HAND,I5,14H  SMALLEST E'S)                                      00930000
      GO TO 430                                                         00940000
  420 NDIFF=1                                                           00950000
      ISCRA=LFOUR                                                       00960000
      WRITE(ISCRA) NDIFF                                                00970000
      WRITE(ISCRA) ITLE,ICENT,LATT,NSYM,((TS(I,J),(IS(K,I,J),K=1,2),    00980000
     1 I=1,3),J=1,NSYM),(NDIFF,I=1,3),(CX(I),I=1,6),NASU                00990000
      EN=0.0                                                            01000000
      ER=0.0                                                            01010000
      SC=SQRT(SCAL(1))                                                  01020000
      IF(SC.LT.0.01) SC=1.0                                             01030000
C**** READ REFLEXION DATA FROM CARDS                                    01040001
  430 IF(IABS(NPC).LE.12) CALL CARDIN                                   01050000
C**** READ REFLEXION DATA FROM BINARY FILE                              01060001
      IF(IABS(NPC).GT.12) CALL TAPEIN                                   01070000
      IF(NDIFF.EQ.1) CALL RFAC                                          01080000
      IF(NDIFF.EQ.1) GO TO 700                                          01090009
      NB=8.0*ALOG10(0.05*FLOAT(MAX0(NREF,100))+0.5)                     01100000
C**** MAXIMUM OF 30 POINTS ON WILSON PLOT                               01110001
      IF(NB.GT.30) NB=30                                                01120000
      WRITE(LO,440) NREF,RHOMAX,NB                                      01130000
  440 FORMAT(//23H0NUMBER OF REFLEXIONS =,I6,8X,                        01140000
     1 32HMAXIMUM (SIN(THETA)/LAMBDA)**2 =,F7.4,8X,                     01150000
     2 33HNUMBER OF POINTS ON WILSON PLOT =,I3)                         01160000
      IF(JUMP.GE.0) GO TO 450                                           01170000
C**** OBTAIN SUMS FOR WILSON PLOT AND FIT LEAST SQUARES STRAIGHT LINE   01180001
      CALL SUM(PTS)                                                     01190000
C**** PLOT WILSON AND DEBYE CURVES AND LEAST SQUARES STRAIGHT LINE      01200001
      CALL GRAPH(NGP)                                                   01210000
  450 BT=2.0*BT                                                         01220000
      IF(JUMP.GE.0) SC=1.0                                              01230000
C**** CALCULATE SCALE FACTORS FOR APPROPRIATE REFLEXION GROUPS          01240001
      CALL RESCA(KSYS,ISC,JUMP)                                         01250000
C**** OUTPUT FOR MULTAN                                                 01260001
      IF(MM.LT.0) GO TO 500                                             01270000
      WRITE(LNTA,460) ITLE,(CX(I),I=1,6),NW,NO,ICENT,LATB,NSYM,NGP,NASU 01280000
  460 FORMAT(20A4/6F10.5/16I5/I5,4X,A1,3I5)                             01290000
      WRITE(LNTA,470) ((TS(I,J),(IS(K,I,J),K=1,2),I=1,3),J=1,NSYM)      01300000
  470 FORMAT(3(F11.8,2I2))                                              01310000
      IF(NGP.EQ.0) GO TO 500                                            01320000
      NF=0                                                              01330000
      DO 490 I=1,NGP                                                    01340000
      NS=NF+1                                                           01350000
      NF=NF+NAG(I)                                                      01360000
      WRITE(LNTA,480) NINF(I),NAG(I),(NZ(J),X(J),Y(J),Z(J),J=NS,NF)     01370000
  480 FORMAT(2I5/(I5,3F10.6))                                           01380000
  490 CONTINUE                                                          01390000
C**** CALCULATE FINAL E'S AND OUTPUT REFLEXION STATISTICS               01400001
  500 CALL ECAL(KSYS)                                                   01410000
      IF(NGP.LE.0) GO TO 700                                            01420000
      NF=0                                                              01430000
      DO 600 IGP=1,NGP                                                  01440000
      NS=NF+1                                                           01450000
      NF=NF+NAG(IGP)                                                    01460000
      IF(NINF(IGP).LT.5) GO TO 600                                      01470000
      CALL RECYC(NS,NF,BT)                                              01480000
      GO TO 700                                                         01490000
  600 CONTINUE                                                          01500000
  700 WRITE(6,4001)                                                     01510009
 4001 FORMAT(//,' ',11('****'),'**     E I N D E   P R O G R A M M A    01520000
     * **',11('****'))                                                  01530000
      STOP                                                              01540009
      END                                                               01550000
C**** ------------------------------------------------------------------01560001
C**** FREE FORMAT INPUT ROUTINE                                         01570001
      SUBROUTINE TRANSL(JUMP,BT)                                        01580000
      COMMON/FFREAD/IDIV(8),IB(8)                                       01590000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    01600000
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT,LATB      01610000
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           01630000
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF                             01640000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        01650000
      DIMENSION LETT(26),N(80),KX(10),POP(10),NA(8),CR(9,10)            01660000
      DATA LETT/1HA,1HB,1HC,1HD,1HE,1HF,1HG,1HH,1HI,1HJ,1HK,1HL,1HM,    01670000
     1 1HN,1HO,1HP,1HQ,1HR,1HS,1HT,1HU,1HV,1HW,1HX,1HY,1HZ/             01680000
      DATA KX/1H0,1H1,1H2,1H3,1H4,1H5,1H6,1H7,1H8,1H9/                  01690000
      DATA KSP/1H /,KM/1H-/,KD/1H./                                     01700000
C**** SET INITIAL AND DEFAULT VALUES                                    01710001
      TH=1.0                                                            01720000
      EN=1.2                                                            01730000
      ER=0.3                                                            01740000
      MZ=100                                                            01750000
      MM=0                                                              01760000
      NSYM=1                                                            01770000
      NTOT=0                                                            01780000
      NGP=0                                                             01790000
      IK=1                                                              01800000
      NB=0                                                              01810000
      ISC=0                                                             01820000
      LST=0                                                             01830000
      BT=0.0                                                            01840000
      DO 10 I=1,8                                                       01850000
      NW(I)=0                                                           01860000
      NO(I)=0                                                           01870000
      SCAL(I)=0.0                                                       01880000
   10 CONTINUE                                                          01890000
      DO 20 I=1,100                                                     01900000
      X(I)=0.0                                                          01910000
      Y(I)=0.0                                                          01920000
      Z(I)=0.0                                                          01930000
   20 CONTINUE                                                          01940000
      NPC=15                                                            01950000
      LATT=LETT(16)                                                     01960000
      JUMP=-1                                                           01970000
      ICENT=0                                                           01980000
      IND=1                                                             01990000
      KS=1                                                              02000000
      READ(LN,90) N                                                     02010000
   90 FORMAT(80A1)                                                      02020000
  100 KEY=0                                                             02030000
      IKW=0                                                             02040000
      IC=0                                                              02050000
      IMK=0                                                             02060000
      IM=1                                                              02070000
  110 DO 200 I=KS,80                                                    02080000
      DO 120 K=1,26                                                     02090000
      IF(LETT(K).EQ.N(I)) GO TO 190                                     02100000
  120 CONTINUE                                                          02110000
      IF(IKW.EQ.0) GO TO 200                                            02120000
      IF(IKW.LT.3.AND.N(I).EQ.KSP) GO TO 185                            02130000
      IF(IKW.LT.3) GO TO 3000                                           02140000
      IF(IC.GT.8) GO TO 200                                             02150000
      DO 130 K=1,10                                                     02160000
      IF(KX(K).EQ.N(I)) GO TO 180                                       02170000
  130 CONTINUE                                                          02180000
      IF(N(I).EQ.KD) GO TO 170                                          02190000
      IF(N(I).EQ.KM) GO TO 150                                          02200000
      IM=1                                                              02210000
      IF(N(I).EQ.KSP) GO TO 160                                         02220000
      GO TO 3000                                                        02230000
  150 IM=-1                                                             02240000
  160 IF(IMK.LE.0) IC=IC+1                                              02250000
C**** TEST FOR CARD                                                     02260001
      IF(KEY.EQ.30118.AND.IC.GE.2) GO TO 1950                           02270000
      IF(IC.GT.8) GO TO 200                                             02280000
      IB(IC)=0                                                          02290000
      IDIV(IC)=0                                                        02300000
      IMK=1                                                             02310000
      GO TO 200                                                         02320000
  170 IMK=-1                                                            02330000
      GO TO 200                                                         02340000
  180 IB(IC)=IM*(10*IABS(IB(IC))+K-1)                                   02350000
      IF(IMK.EQ.1) IMK=0                                                02360000
      IF(IMK.LT.0) IDIV(IC)=IDIV(IC)-1                                  02370000
      GO TO 200                                                         02380000
  185 GO TO (3000,2000,2100,2200,2300),IND                              02390000
  190 IF(IC.GT.0) GO TO 210                                             02400000
      IF(IKW.GE.3) GO TO 200                                            02410000
      IKW=IKW+1                                                         02420000
      KEY=100*KEY+K                                                     02430000
C**** TEST FOR SYMMETRY INPUT                                           02440001
      IF(KEY.EQ.192513) GO TO 1200                                      02450000
C**** TEST FOR TAPE                                                     02460001
      IF(KEY.EQ.200116) GO TO 2800                                      02470000
  200 CONTINUE                                                          02480000
      KS=1                                                              02490000
      READ(LN,90) N                                                     02500000
      GO TO 110                                                         02510000
  210 KS=I                                                              02520000
      IF(KEY.EQ.1000) GO TO 2150                                        02530000
      IF(KEY.EQ.2000) GO TO 2250                                        02540000
      IF(KEY.EQ.3000) GO TO 2350                                        02550000
C**** LATTICE                                                           02560001
      IF(KEY.EQ.120120) GO TO 1000                                      02570000
C**** NONCENTROSYMMETRIC                                                02580001
      IF(KEY.EQ.141514) GO TO 100                                       02590000
C**** CENTROSYMMETRIC                                                   02600001
      IF(KEY.EQ.30514) GO TO 1110                                       02610000
C**** LINEAR                                                            02620001
      IF(KEY.EQ.120914) GO TO 1120                                      02630000
C**** NOSCALE                                                           02640001
      IF(KEY.EQ.141519) GO TO 1130                                      02650000
C**** LIST                                                              02660001
      IF(KEY.EQ.120919) GO TO 1140                                      02670000
C**** RANDOM                                                            02680001
      IF(KEY.EQ.180114) GO TO 1147                                      02690000
C**** ORIENTED                                                          02700001
      IF(KEY.EQ.151809) GO TO 1149                                      02710000
C**** POSITIONED                                                        02720001
      IF(KEY.EQ.161519) GO TO 1151                                      02730000
C**** KARLE                                                             02740001
      IF(KEY.EQ.110118) GO TO 1153                                      02750000
C**** WEIGHTED FOURIER                                                  02760001
      IF(KEY.EQ.230615) GO TO 1155                                      02770000
C**** DIFFERENCE FOURIER                                                02780001
      IF (KEY.EQ.40615) GOTO 1156                                       02790000
C**** CREATE                                                            02800001
      IF(KEY.EQ.31805) GO TO 1160                                       02810000
C**** NREF                                                              02820001
      IF(KEY.EQ.141805) GO TO 1350                                      02830000
C**** EMIN                                                              02840001
      IF(KEY.EQ.51309) GO TO 1400                                       02850000
C**** NZRO                                                              02860001
      IF(KEY.EQ.142618) GO TO 1450                                      02870000
C**** EINPUT                                                            02880001
      IF(KEY.EQ.50914) GO TO 1500                                       02890000
C**** RHOMAX                                                            02900001
      IF(KEY.EQ.180815) GO TO 1550                                      02910000
C**** BFAC                                                              02920001
      IF(KEY.EQ.20601) GO TO 1600                                       02930000
C**** SCALE                                                             02940001
      IF(KEY.EQ.190301) GO TO 1650                                      02950000
C**** CELL                                                              02960001
      IF(KEY.EQ.30512) GO TO 1700                                       02970000
C**** CONTENTS                                                          02980001
      IF(KEY.EQ.31514) GO TO 1750                                       02990000
C**** FACTORS                                                           03000001
      IF(KEY.EQ.60103) GO TO 1800                                       03010000
C**** MULTIPLICITY                                                      03020001
      IF(KEY.EQ.132112) GO TO 1900                                      03030000
      GO TO 3000                                                        03040000
 1000 IND=2                                                             03050000
      GO TO 100                                                         03060000
 1110 ICENT=1                                                           03070000
      GO TO 100                                                         03080000
 1120 IK=0                                                              03090000
      WRITE(LO,1125)                                                    03100000
 1125 FORMAT(1H0,28X,64HNORMALISATION BY LEAST SQUARES STRAIGHT LINE THR03110000
     1OUGH DEBYE CURVE)                                                 03120000
      GO TO 100                                                         03130000
 1130 ISC=1                                                             03140000
      WRITE(LO,1135)                                                    03150000
 1135 FORMAT(1H0,48X,24HNO INDEX GROUP RESCALING)                       03160000
      GO TO 100                                                         03170000
 1140 LST=1                                                             03180000
      WRITE(LO,1145)                                                    03190000
 1145 FORMAT(1H0,45X,29HLIST COMPLETE SET OF E-VALUES)                  03200000
      GO TO 100                                                         03210000
 1147 IND=2                                                             03220000
      GO TO 1157                                                        03230000
 1149 IND=3                                                             03240000
      GO TO 1157                                                        03250000
 1151 IND=4                                                             03260000
      GO TO 1157                                                        03270000
 1153 IND=5                                                             03280000
      GO TO 1157                                                        03290000
 1155 IND=6                                                             03300000
      GOTO 1157                                                         03310000
 1156 IND=7                                                             03320000
 1157 NGP=NGP+1                                                         03330000
      NINF(NGP)=IND                                                     03340000
      IND=4                                                             03350000
      NAG(NGP)=0                                                        03360000
      GO TO 100                                                         03370000
 1160 NPC=-IABS(NPC)                                                    03380000
      GO TO 100                                                         03390000
C**** SET UP LINE FOR ISYM; READ TO SPACE, THEN TO NON-SPACE            03400001
 1200 KS=MAX0(1,MOD(KS+1,81))                                           03410000
      IF (KS.EQ.1) READ (LN,90) N                                       03420000
      IF (N(KS).NE.KSP) GOTO 1200                                       03430000
 1300 KS=MAX0(1,MOD(KS+1,81))                                           03440000
      IF (KS.EQ.1) READ (LN,90) N                                       03450000
      IF (N(KS).EQ.KSP) GOTO 1300                                       03460000
      KS=KS-1                                                           03470000
      CALL INSYM(N,KS)                                                  03480000
      GO TO 100                                                         03490000
 1350 MM=IB(1)                                                          03500000
      GO TO 100                                                         03510000
 1400 EN=FLOAT(IB(1))*10.0**IDIV(1)                                     03520000
      GO TO 100                                                         03530000
 1450 MZ=IB(1)                                                          03540000
      GO TO 100                                                         03550000
 1500 BT=0.0                                                            03560000
      SCAL(1)=1.0                                                       03570000
      IK=-1                                                             03580000
      GO TO 100                                                         03590000
 1550 TH=FLOAT(IB(1))*10.0**IDIV(1)                                     03600000
      GO TO 100                                                         03610000
 1600 BT=FLOAT(IB(1))*10.0**IDIV(1)                                     03620000
      WRITE(LO,1610) BT                                                 03630000
 1610 FORMAT(1H0,40X,33HSUPPLIED TEMPERATURE FACTOR (B) =,F6.2)         03640000
      JUMP=JUMP+1                                                       03650000
      GO TO 100                                                         03660000
 1650 DO 1660 J=1,8                                                     03670000
      IF(J.LT.IC) SCAL(J)=FLOAT(IB(J))*10.0**IDIV(J)                    03680000
 1660 CONTINUE                                                          03690000
      WRITE(LO,1670) SCAL                                               03700000
 1670 FORMAT(1H0,23X,26HSUPPLIED SCALE FACTORS ARE,8F6.2/1H ,32X,       03710000
     1 56HFOR APPROPRIATE INDEX GROUPS SEE RESCALING SECTION BELOW)     03720000
      JUMP=JUMP+1                                                       03730000
      GO TO 100                                                         03740000
 1700 IF(IC.NE.7) GO TO 3000                                            03750000
      DO 1710 J=1,6                                                     03760000
      IF(NGP.EQ.0) CX(J)=FLOAT(IB(J))*10.0**IDIV(J)                     03770000
      IF(NGP.GT.0) CR(J,NGP)=FLOAT(IB(J))*10.0**IDIV(J)                 03780000
 1710 CONTINUE                                                          03790000
      IF(NGP.EQ.0) CALL INCELL                                          03800000
      GO TO 100                                                         03810000
 1750 NK=0                                                              03820000
      IND=3                                                             03830000
      GO TO 100                                                         03840000
 1800 IND=5                                                             03850000
      GO TO 100                                                         03860000
 1900 POP(NGP)=FLOAT(IB(1))*10.0**IDIV(1)                               03870000
      GO TO 100                                                         03880000
 1950 NPC=ISIGN(IB(1),NPC)                                              03890000
      GO TO 2800                                                        03900000
 2000 LATT=LETT(KEY)                                                    03910000
      KS=KS+1                                                           03920000
      GO TO 100                                                         03930000
 2100 NK=NK+1                                                           03940000
      NW(NK)=KEY                                                        03950000
      KEY=1000                                                          03960000
      IKW=3                                                             03970000
      GO TO 110                                                         03980000
 2150 NA(NK)=IB(1)                                                      03990000
      GO TO 100                                                         04000000
 2200 NAG(NGP)=NAG(NGP)+1                                               04010000
      NTOT=NTOT+1                                                       04020000
      DO 2210 I=1,NK                                                    04030000
      IF(KEY.EQ.NW(I)) GO TO 2230                                       04040000
 2210 CONTINUE                                                          04050000
      GO TO 3000                                                        04060000
 2230 NZ(NTOT)=I                                                        04070000
      KEY=2000                                                          04080000
      IKW=3                                                             04090000
      GO TO 110                                                         04100000
 2250 IF(IC.GT.1) X(NTOT)=FLOAT(IB(1))*10.0**IDIV(1)                    04110000
      IF(IC.GT.2) Y(NTOT)=FLOAT(IB(2))*10.0**IDIV(2)                    04120000
      IF(IC.GT.3) Z(NTOT)=FLOAT(IB(3))*10.0**IDIV(3)                    04130000
      GO TO 100                                                         04140000
 2300 DO 2310 JF=1,NK                                                   04150000
      IF(KEY.EQ.NW(JF)) GO TO 2320                                      04160000
 2310 CONTINUE                                                          04170000
      GO TO 3000                                                        04180000
 2320 KEY=3000                                                          04190000
      IKW=3                                                             04200000
      GO TO 110                                                         04210000
C
C  NOTADAPTED TO CHAGES IN SCATTERING FACTOR TABLES
C  DO NOT USE THIS PROGRAM AS A STAND ALONE NORMALIZING
C  TOOL. GET THE ORIGINAL
C
 2350 AL(JF)=FLOAT(IB(1))*10.0**IDIV(1)                                 04220000
      AS(JF)=FLOAT(IB(2))*10.0**IDIV(2)                                 04230000
      BL(JF)=FLOAT(IB(3))*10.0**IDIV(3)                                 04240000
      BS(JF)=FLOAT(IB(4))*10.0**IDIV(4)                                 04250000
      CL(JF)=FLOAT(IB(5))*10.0**IDIV(5)                                 04260000
      IF(IC.NE.6) GO TO 3000                                            04270000
      GO TO 100                                                         04280000
 2800 CALL ATREC                                                        04290000
      NAT=0                                                             04300000
      DO 2805 I=1,80                                                    04310000
      N(I)=KSP                                                          04320000
 2805 CONTINUE                                                          04330000
      DO 2810 I=1,NK                                                    04340000
      K=NW(I)/100                                                       04350000
      J=NW(I)-100*K                                                     04360000
      IF (K.GT.0) N(I)=LETT(K)                                          04370000
      IF (J.GT.0) N(I+40)=LETT(J)                                       04380000
      NW(I)=NA(I)                                                       04390000
      NO(I)=INT(AL(I)+BL(I)+CL(I)+DL(I)+EL(I)+0.5)
      IF(NO(I).NE.1) NAT=NAT+NA(I)                                      04410000
 2810 CONTINUE                                                          04420000
      WRITE(LO,2820) (N(I),N(I+40),NA(I),NO(I),AL(I),AS(I),BL(I),BS(I), 04430000
     1 CL(I),CS(I),DL(I),DS(I),EL(I),I=1,NK)
 2820 FORMAT(//1H0,51X,18HUNIT CELL CONTENTS//               
     1 1H ,4HATOM,4X,14HNUMBER IN CELL,4X,13HATOMIC NUMBER,4X,
     2 'SCATTERING FACTOR CONSTANTS',/,   
     3' (F=AA*EXP(-A*RHO)+BB*EXP(-B*RHO)+CC*EXP(-C*RHO)+DD*EXP(-D*RHO)',
     4 '+EE)',/,
     5 (1H ,1X,2A1,I14,I17,9F8.3))
      DO 2830 I=1,142                                                   04500000
      GIS(I)=0.0                                                        04510000
 2830 CONTINUE                                                          04520000
      IF(NGP.EQ.0) GO TO 2880                                           04530000
      NF=0                                                              04540000
      DO 2870 I=1,NGP                                                   04550000
      NS=NF+1                                                           04560000
      NF=NF+NAG(I)                                                      04570000
      WRITE(LO,2840) I,NAG(I),POP(I)                                    04580000
 2840 FORMAT(/1H0,11X,14HGROUP NUMBER =,I5,27X,                         04590000
     1 26HNUMBER OF ATOMS IN GROUP =,I3,4X,14HMULTIPLICITY =,F5.1)      04600000
      IF(NINF(I).EQ.2) WRITE(LO,2842)                                   04610000
 2842 FORMAT(1H+,35X,17HRANDOMLY ORIENTED)                              04620000
      IF(NINF(I).EQ.3) WRITE(LO,2843)                                   04630000
 2843 FORMAT(1H+,35X,18HCORRECTLY ORIENTED)                             04640000
      IF(NINF(I).EQ.4) WRITE(LO,2844)                                   04650000
 2844 FORMAT(1H+,34X,20HCORRECTLY POSITIONED)                           04660000
      IF(NINF(I).EQ.5) WRITE(LO,2845)                                   04670000
 2845 FORMAT(1H+,34X,19HFOR KARLE RECYCLING)                            04680000
      IF(NINF(I).EQ.6) WRITE(LO,2846)                                   04690000
 2846 FORMAT(1H+,34X,20HFOR WEIGHTED FOURIER)                           04700000
      IF(NINF(I).EQ.7) WRITE (LO,2847)                                  04710000
 2847 FORMAT(1H+,33X,22HFOR DIFFERENCE FOURIER)                         04720000
      DO 2860 J=NS,NF                                                   04730000
      K=NZ(J)                                                           04740000
      IF(NINF(I).LE.2.OR.NINF(I).EQ.6) NA(K)=NA(K)-INT(POP(I)+0.5)      04750000
      WRITE(LO,2850) N(K),N(K+40),X(J),Y(J),Z(J)                        04760000
 2850 FORMAT(1H ,36X,2A1,3F15.4)                                        04770000
 2860 CONTINUE                                                          04780000
C**** CALCULATE SPHERICALLY AVERAGED MOLECULAR SCATTERING FACTORS       04790001
      DO 2865 J=1,6                                                     04800000
      F(J)=CR(J,I)                                                      04810000
 2865 CONTINUE                                                          04820000
      IF(NINF(I).EQ.2) CALL DEBYE(NS,NF,F,POP(I))                       04830000
 2870 CONTINUE                                                          04840000
C**** CALCULATE WILSON (GIW) AND DEBYE (GIS) SCATTERING FACTORS         04850001
 2880 DO 2900 I=1,142                                                   04860000
      T=0.01*FLOAT(I-1)                                                 04870000
      TT=T*T                                                            04880000
      GIW(I)=0.0                                                        04890000
      DO 2890 J=1,NK                                                    04900000
      FZ=AL(J)*EXP(-AS(J)*TT)+BL(J)*EXP(-BS(J)*TT)+CL(J)*EXP(-CS(J)*TT)
     1 + DL(J)*EXP(-DS(J)*TT)+EL(J)
      GIS(I)=GIS(I)+FZ*FZ*FLOAT(NA(J))                                  04920000
      GIW(I)=GIW(I)+FZ*FZ*FLOAT(NW(J))                                  04930000
 2890 CONTINUE                                                          04940000
 2900 CONTINUE                                                          04950000
      IF(JUMP.GE.0) IK=0                                                04960000
      RETURN                                                            04970000
 3000 WRITE(LO,3010) N                                                  04980000
 3010 FORMAT(14H ERROR IN LINE,5X,80A1)                                 04990000
      STOP                                                              05000000
      END                                                               05010000
C**** ------------------------------------------------------------------05020001
C**** INPUT UNIT CELL PARAMETERS AND CALCULATE RECIPROCAL PARAMETERS    05030001
      SUBROUTINE INCELL                                                 05040000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    05050000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        05060000
      WRITE(LO,20) (CX(I),I=1,6)                                        05070000
   20 FORMAT(1H0,11HDIRECT CELL,9X,3HA =,F8.3,4X,3HB =,F8.3,4X,         05080000
     1 3HC =,F8.3,4X,7HALPHA =,F7.2,4X,6HBETA =,F7.2,4X,7HGAMMA =,F7.2) 05090000
      CALL VOL(CX,V)                                                    05100000
C**** VOLUME AND RECIPROCAL CELL FUNCTIONS                              05110001
      V=1.0/(V*CX(1)*CX(2)*CX(3))                                       05120000
      P(1)=CX(2)*CX(3)*CX(7)*V                                          05130000
      P(2)=CX(1)*CX(3)*CX(8)*V                                          05140000
      P(3)=CX(1)*CX(2)*CX(9)*V                                          05150000
      P(4)=0.5*P(1)*P(2)*(CX(4)*CX(5)-CX(6))/(CX(7)*CX(8))              05160000
      P(5)=0.5*P(1)*P(3)*(CX(4)*CX(6)-CX(5))/(CX(7)*CX(9))              05170000
      P(6)=0.5*P(2)*P(3)*(CX(5)*CX(6)-CX(4))/(CX(8)*CX(9))              05180000
      DO 40 I=1,3                                                       05190000
      P(I)=0.25*P(I)*P(I)                                               05200000
      CX(I+3)=180.0*ATAN2(CX(I+6),CX(I+3))/PI                           05210000
   40 CONTINUE                                                          05220000
      WRITE(LO,50) P                                                    05230000
   50 FORMAT(6H0RHO =,F9.6,9H * H**2 +,F9.6,9H * K**2 +,F9.6,9H * L**2 +05240000
     1 ,F9.6,10H * H * K +,F9.6,10H * H * L +,F9.6,8H * K * L)          05250000
      RETURN                                                            05260000
      END                                                               05270000
C**** ------------------------------------------------------------------05280001
C**** SINE AND COSINE OF CELL ANGLES PLUS TRIGONOMETRIC PART OF VOLUME  05290001
      SUBROUTINE VOL(CX,V)                                              05300000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    05310000
      DIMENSION CX(9)                                                   05320000
      DTOR=PI/180.0                                                     05330000
      ARG=1.0                                                           05340000
      DO 10 I=4,6                                                       05350000
      CX(I+3)=SIN(DTOR*CX(I))                                           05360000
      CX(I)=COS(DTOR*CX(I))                                             05370000
      ARG=ARG-CX(I)*CX(I)                                               05380000
   10 CONTINUE                                                          05390000
      V=SQRT(ARG+2.0*CX(4)*CX(5)*CX(6))                                 05400000
      RETURN                                                            05410000
      END                                                               05420000
C**** ------------------------------------------------------------------05430001
C**** READ GENERAL EQUIVALENT POSITIONS AS IN INTERNATIONAL TABLES AND  05440001
C**** DETERMINE LATTICE MULTIPLICITY (PTS) AND CRYSTAL SYSTEM (KSYS)    05450001
      SUBROUTINE INSYM(N,KS)                                            05460000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    05470000
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT,LATB      05480000
      DIMENSION N(80),KX(15),LTC(7),ICAP(2),LINE(21)                    05490000
      DATA KX/1H1,1H2,1H3,1H4,1H5,1H6,1HX,1HY,1HZ,1H ,1H,,1H+,1H-,1H/,  05500000
     1 1H*/                                                             05510000
      DATA LTC/1HP,1HA,1HB,1HC,1HI,1HF,1HR/,ICAP/3HNON,3H   /           05520000
      IC=1                                                              05530000
      ISN=1                                                             05540000
      TRV=-1.0                                                          05550000
      IN=1                                                              05560000
   10 KS=MOD(KS+1,80)                                                   05570000
      DO 100 I=KS,81                                                    05580000
      IF(I.EQ.81) GO TO 40                                              05590000
      DO 20 J=1,15                                                      05600000
      IF(N(I).EQ.KX(J)) GO TO 30                                        05610000
   20 CONTINUE                                                          05620000
      ISN=100                                                           05630000
      IF(IN.GE.2) GO TO 40                                              05640000
      NSYM=NSYM-1                                                       05650000
      GO TO 105                                                         05660000
   30 GO TO (90,90,90,90,90,90,80,80,80,100,40,100,60,100,40),J         05670000
C**** END OF LINE, CHARACTER '*' OR NEW KEYWORD                         05680001
   40 IF(IN.EQ.2) IS(2,IC,NSYM)=0                                       05690000
      IF(TRV.LT.0.0) TS(IC,NSYM)=0.0                                    05700000
      IN=1                                                              05710000
      TRV=-1.0                                                          05720000
      IC=IC+1                                                           05730000
      IF(J.EQ.11) GO TO 100                                             05740000
      IF(ISN.GT.10) GO TO 105                                           05750000
      IC=1                                                              05760000
      NSYM=NSYM+1                                                       05770000
      GO TO 100                                                         05780000
C**** CHARACTER = '-'                                                   05790001
   60 ISN=-1                                                            05800000
      GO TO 100                                                         05810000
C**** CHARACTER = 'X', 'Y' OR 'Z'                                       05820001
   80 IS(IN,IC,NSYM)=ISN*(J-6)                                          05830000
      ISN=1                                                             05840000
      IN=IN+1                                                           05850000
      GO TO 100                                                         05860000
C**** CHARACTER = '1' TO '6'                                            05870001
   90 IF(TRV.LT.0.0) TRV=FLOAT(J)                                       05880000
      IF(TRV.GT.0.0) TS(IC,NSYM)=TRV/FLOAT(J)                           05890000
  100 CONTINUE                                                          05900000
      READ(LN,102) N                                                    05910000
  102 FORMAT(80A1)                                                      05920000
      KS=80                                                             05930000
      GO TO 10                                                          05940000
C**** PREPARE 'FORMATTED' OUTPUT                                        05950001
  105 KS=I                                                              05960000
      WRITE(LO,104) ICAP(ICENT+1),NSYM,LATT                             05970000
  104 FORMAT(/1H0,17HTHE STRUCTURE IS ,A3,15HCENTROSYMMETRIC,8X,I3,3X,  05980000
     1 28HGENERAL EQUIVALENT POSITIONS,10X,18HLATTICE IS OF TYPE,3X,A1/)05990000
      DO 200 ISYM=1,NSYM                                                06000000
      DO 110 I=1,21                                                     06010000
      LINE(I)=KX(10)                                                    06020000
  110 CONTINUE                                                          06030000
      DO 170 IC=1,3                                                     06040000
C**** TRANSLATIONAL PART                                                06050001
      INC=7*IC-5                                                        06060000
      IF(TS(IC,ISYM).LT.0.1) GO TO 120                                  06070000
      NUM=1                                                             06080000
      IF(TS(IC,ISYM).GT.0.6) NUM=TS(IC,ISYM)/(1.0-TS(IC,ISYM))+0.1      06090000
      NOM=FLOAT(NUM)/TS(IC,ISYM)+0.1                                    06100000
      LINE(INC-1)=KX(NUM)                                               06110000
      LINE(INC)=KX(14)                                                  06120000
      LINE(INC+1)=KX(NOM)                                               06130000
C**** SYMBOLIC PART                                                     06140001
  120 DO 160 IN=1,2                                                     06150000
      INC=INC+2                                                         06160000
      IF(IS(IN,IC,ISYM)) 130,160,140                                    06170000
C**** NEGATIVE SYMBOL                                                   06180001
  130 LINE(INC)=KX(13)                                                  06190000
      GO TO 150                                                         06200000
C**** POSITIVE SYMBOL                                                   06210001
  140 IF(IN.EQ.2.OR.TS(IC,ISYM).GT.0.1) LINE(INC)=KX(12)                06220000
C**** 'X', 'Y' OR 'Z'                                                   06230001
  150 IARG=IABS(IS(IN,IC,ISYM))+6                                       06240000
      LINE(INC+1)=KX(IARG)                                              06250000
  160 CONTINUE                                                          06260000
  170 CONTINUE                                                          06270000
      WRITE(LO,180) (LINE(I),I=1,21)                                    06280000
  180 FORMAT(1H ,32X,3(7X,3A1,1X,A1,1X,A1,1X,A1,1X,A1))                 06290000
  200 CONTINUE                                                          06300000
C**** DETERMINE LATTICE MULTIPLICITY                                    06310001
C**** PRIMITIVE                                                         06320001
      PTS=1.0                                                           06330000
      DO 250 I=1,7                                                      06340000
      IF(LATT.EQ.LTC(I)) GO TO 260                                      06350000
  250 CONTINUE                                                          06360000
      STOP
C**** Aanpassing NORMAL80 aan MULTAN78 door lattice als character
C**** te printen. Hiervoor moet LATT gebufferd worden voordat deze
C**** omgezet wordt in een getal.                                       06370000
  260 LATB=LATT                                                         06380000
      LATT=I                                                            06380000
      IF(LATT.EQ.7) GO TO 300                                           06390000
C**** A, B, C OR I CENTRED                                              06400001
      IF(LATT.NE.1) PTS=2.0                                             06410000
C**** F CENTRED                                                         06420001
      IF(LATT.EQ.6) PTS=4.0                                             06430000
      GO TO 400                                                         06440000
  300 DO 310 I=1,NSYM                                                   06450000
C**** PRIMITIVE RHOMBOHEDRAL  (PTS=1.0)                                 06460001
      IF(IABS(IS(1,1,I)).EQ.3) GO TO 400                                06470000
  310 CONTINUE                                                          06480000
C**** CENTRED HEXAGONAL                                                 06490001
      PTS=3.0                                                           06500000
C**** DETERMINE CRYSTAL SYSTEM                                          06510001
  400 DO 450 I=1,2                                                      06520000
      DO 440 J=1,NSYM                                                   06530000
      DO 430 IN=1,2                                                     06540000
      IF(IABS(IS(IN,1,J)).EQ.4-I) GO TO 460                             06550000
  430 CONTINUE                                                          06560000
  440 CONTINUE                                                          06570000
  450 CONTINUE                                                          06580000
C**** 1 - TRICLINIC, 2 - MONOCLINIC, 3 - ORTHORHOMBIC                   06590001
      KSYS=MIN0(NSYM,3)                                                 06600000
      GO TO 500                                                         06610000
  460 IF(I.EQ.1) GO TO 480                                              06620000
C**** TETRAGONAL                                                        06630001
      KSYS=4                                                            06640000
      IF(NSYM.EQ.4.OR.NSYM.EQ.8) GO TO 500                              06650000
C**** TRIGONAL OR RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES                06660001
      KSYS=5                                                            06670000
C**** TEST FOR 6-FOLD AXIS - GENERAL FORM -X, -Y, Z + T                 06680001
      DO 470 J=2,NSYM                                                   06690000
      IF(IABS(IS(1,1,J)).GT.1.OR.IABS(IS(2,1,J)).GT.1) GO TO 470        06700000
      IF(IABS(IS(1,2,J)).EQ.1.OR.IABS(IS(2,2,J)).EQ.1) GO TO 470        06710000
C**** HEXAGONAL                                                         06720001
      KSYS=6                                                            06730000
  470 CONTINUE                                                          06740000
      GO TO 500                                                         06750000
C**** CUBIC                                                             06760001
  480 KSYS=8                                                            06770000
C**** PRIMITIVE RHOMBOHEDRAL                                            06780001
      IF(LATT.EQ.7) KSYS=7                                              06790000
      IF(KSYS.EQ.7) LATT=1                                              06800000
  500 RETURN                                                            06810000
      END                                                               06820000
C**** ------------------------------------------------------------------06830001
C**** INPUT INFORMATION ABOUT CELL CONTENTS AND MOLECULAR FRAGMENTS     06840001
C**** CALCULATE SPHERICAL SCATTERING FACTORS                            06850001
      SUBROUTINE ATREC                                                  06860000
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      DIMENSION ALT(100),AST(100),BLT(100),BST(100),CLT(100),N1(100)
      DIMENSION CST(100),DLT(100),DST(100),ELT(100)
      DATA ALT /
     *   0.388   ,   0.873400,   1.56    ,   1.261   ,   1.207   ,
     *   2.112   ,   3.188   ,   4.197   ,   5.155   ,   3.95530 ,
     *   7.448   ,   7.426   ,   7.276   ,   6.988   ,   6.509   ,
     *   5.967   ,   5.557   ,   7.48450 ,   8.21860 ,   8.62660 ,
     *   9.18900 ,   9.75950 ,  10.2971  ,   10.6406 ,  11.2819  ,
     *  11.7695  ,  12.2841  ,  12.8376  ,  13.3380  ,  14.0743  ,
     *  15.2354  ,  16.0816  ,  16.6723  ,  17.0006  ,  17.1789  ,
     *  17.3555  ,  17.1784  ,  17.5663  ,  17.7760  ,  17.8765  ,
     *  17.6142  ,   3.70250 ,  19.1301  ,  19.2674  ,  19.2957  ,
     *  19.3319  ,  19.2808  ,  19.2214  ,  19.1624  ,  19.1889  ,
     *  19.6418  ,  19.9644  ,  20.1472  ,  20.2933  ,  20.3892  ,
     *  20.3361  ,  20.5780  ,  21.1671  ,  22.0440  ,  22.6845  ,
     *  23.3405  ,  24.0042  ,  24.6274  ,  25.0709  ,  25.8976  ,
     *  26.5070  ,  26.9049  ,  27.6563  ,  28.1819  ,  28.6641  ,
     *  28.9476  ,  29.1440  ,  29.2024  ,  29.0818  ,  28.7621  ,
     *  28.1894  ,  27.3049  ,  27.0059  ,  16.8819  ,  20.6809  ,
     *  27.5446  ,  31.0617  ,  33.3689  ,  34.6726  ,  35.3163  ,
     *  35.5631  ,  35.9299  ,  35.7630  ,  35.6597  ,  35.5645  ,
     *  35.8847  ,  36.0228  ,  36.1874  ,  36.5254  ,  36.6706  ,
     *  36.6488  ,  36.7881  ,  36.9185  ,   0.0     ,   0.0     /
      DATA AST /
     *   7.151   ,   9.10370 ,   3.264   ,   2.620   ,   5.745   ,
     *   7.827   ,   7.341   ,   6.327   ,   5.392   ,   8.40420 ,
     *   4.821   ,   3.770   ,   3.143   ,   2.739   ,   2.602   ,
     *   2.753   ,   3.176   ,   0.907200,  12.7949  ,  10.4421  ,
     *   9.02130 ,   7.85080 ,   6.86570 ,   6.10380 ,   5.34090 ,
     *   4.76110 ,   4.27910 ,   3.87850 ,   3.58280 ,   3.26550 ,
     *   3.06690 ,   2.85090 ,   2.63450 ,   2.40980 ,   2.17230 ,
     *   1.93840 ,   1.78880 ,   1.55640 ,   1.40290 ,   1.27618 ,
     *   1.18865 ,   0.277200,   0.864132,   0.808520,   0.751536,
     *   0.698655,   0.644600,   0.594600,   0.547600,   5.83030 ,
     *   5.30340 ,   4.81742 ,   4.34700 ,   3.92820 ,   3.56900 ,
     *   3.21600 ,   2.94817 ,   2.81219 ,   2.77393 ,   2.66248 ,
     *   2.56270 ,   2.47274 ,   2.38790 ,   2.25341 ,   2.24256 ,
     *   2.18020 ,   2.07051 ,   2.07356 ,   2.02859 ,   1.98890 ,
     *   1.90182 ,   1.83262 ,   1.77333 ,   1.72029 ,   1.67191 ,
     *   1.62903 ,   1.59279 ,   1.51293 ,   0.461100,   0.545000,
     *   0.655150,   0.690200,   0.704000,   0.700999,   0.685870,
     *   0.663100,   0.646453,   0.616341,   0.589092,   0.563359,
     *   0.547751,   0.529300,   0.511929,   0.499384,   0.483629,
     *   0.465154,   0.451018,   0.437533,   0.0     ,   0.0     /
      DATA BLT/
     *   0.601   ,   0.630900,   1.059   ,   2.008   ,   2.530   ,
     *   2.462   ,   2.305   ,   2.218   ,   2.172   ,   3.11250 ,
     *   1.280   ,   2.267   ,   3.192   ,   4.169   ,   5.107   ,
     *   5.925   ,   6.573   ,   6.77230 ,   7.43980 ,   7.38730 ,
     *   7.36790 ,   7.35580 ,   7.35110 ,   7.35370 ,   7.35730 ,
     *   7.35730 ,   7.34090 ,   7.29200 ,   7.16760 ,   7.03180 ,
     *   6.70060 ,   6.37470 ,   6.07010 ,   5.81960 ,   5.23580 ,
     *   6.72860 ,   9.64350 ,   9.81840 ,  10.2946  ,  10.9480  ,
     *  12.0144  ,  17.2356  ,  11.0948  ,  12.9182  ,  14.3501  ,
     *  15.5017  ,  16.6885  ,  17.6444  ,  18.5596  ,  19.1005  ,
     *  19.0455  ,  19.0138  ,  18.9949  ,  19.0298  ,  19.1062  ,
     *  19.2970  ,  19.5990  ,  19.7695  ,  19.6697  ,  19.6847  ,
     *  19.6095  ,  19.4258  ,  19.0886  ,  19.0798  ,  18.2185  ,
     *  17.6383  ,  17.2940  ,  16.4285  ,  15.8851  ,  15.4345  ,
     *  15.2208  ,  15.1726  ,  15.2293  ,  15.4300  ,  15.7189  ,
     *  16.1550  ,  16.7296  ,  17.7639  ,  18.5913  ,  19.0417  ,
     *  19.1584  ,  13.0637  ,  12.9510  ,  15.4733  ,  19.0211  ,
     *  21.2816  ,  23.0547  ,  22.9064  ,  23.1032  ,  23.4219  ,
     *  23.2948  ,  23.4128  ,  23.5964  ,  23.8083  ,  24.0992  ,
     *  24.4096  ,  24.7736  ,  25.1995  ,   0.0     ,   0.0     /
      DATA BST /
     *  30.18    ,   3.35680 ,  108.3    ,   54.77   ,  38.23    ,
     *  31.65    ,  26.84    ,  22.83    ,   19.61   ,   3.42620 ,
     *  96.71    ,  69.72    ,  55.67    ,  43.28    ,  34.46    ,
     *  28.44    ,  24.26    ,  14.8407  ,   0.774800,   0.659900,
     *   0.572900,   0.500000,   0.438500,   0.392000,   0.343200,
     *   0.307200,   0.278400,   0.256500,   0.247000,   0.233300,
     *   0.241200,   0.251600,   0.264700,   0.272600,  16.5796  ,
     *  16.5623  ,  17.3151  ,  14.0988  ,  12.8006  ,  11.9160  ,
     *  11.7660  ,   1.09580 ,   8.14487 ,   8.43467 ,   8.21758 ,
     *   7.98929 ,   7.47260 ,   6.90890 ,   6.37760 ,   0.503100,
     *   0.460700,   0.420885,   0.381400,   0.344000,   0.310700,
     *   0.275600,   0.244475,   0.226836,   0.222087,   0.210628,
     *   0.202088,   0.196451,   0.194200,   0.181951,   0.196143,
     *   0.202172,   0.197940,   0.223545,   0.238849,   0.257119,
     *   9.98519 ,   9.59990 ,   9.37046 ,   9.22590 ,   9.09227 ,
     *   8.97948 ,   8.86553 ,   8.81174 ,   8.62160 ,   8.44840 ,
     *   8.70751 ,   2.35760 ,   2.92380 ,   3.55078 ,   3.97458 ,
     *   4.06910 ,   4.17619 ,   3.87135 ,   3.65155 ,   3.46204 ,
     *   3.41519 ,   3.32530 ,   3.25396 ,   3.26371 ,   3.20647 ,
     *   3.08997 ,   3.04619 ,   3.00775 ,   0.0     ,   0.0     /
      DATA CLT /
     *   0.0     ,   0.311200,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   1.45460 ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.653900,   1.05190 ,   1.58990 ,
     *   1.64090 ,   1.69910 ,   2.07030 ,   3.32400 ,   3.01930 ,
     *   3.52220 ,   4.00340 ,   4.44380 ,   5.61580 ,   5.16520 ,
     *   4.35910 ,   3.70680 ,   3.43130 ,   3.97310 ,   5.63770 ,
     *   5.54930 ,   5.13990 ,   5.42200 ,   5.72629 ,   5.41732 ,
     *   4.04183 ,  12.8876  ,   4.64901 ,   4.86337 ,   4.73425 ,
     *   5.29537 ,   4.80450 ,   4.46100 ,   4.29480 ,   4.45850 ,
     *   5.03710 ,   6.14487 ,   7.51380 ,   8.97670 ,  10.6620  ,
     *  10.8880  ,  11.3727  ,  11.8513  ,  12.3856  ,  12.7740  ,
     *  13.1235  ,  13.4396  ,  13.7603  ,  13.8518  ,  14.3167  ,
     *  14.5596  ,  14.5583  ,  14.9779  ,  15.1542  ,  15.3087  ,
     *  15.1000  ,  14.7586  ,  14.5135  ,  14.4327  ,  14.5564  ,
     *  14.9305  ,  15.6115  ,  15.7131  ,  25.5582  ,  21.6575  ,
     *  15.5380  ,  18.4420  ,  16.5877  ,  13.1138  ,   9.49887 ,
     *   8.00370 ,  12.1439  ,  12.4739  ,  12.5977  ,  12.7473  ,
     *  14.1891  ,  14.9491  ,  15.6402  ,  16.7707  ,  17.3415  ,
     *  17.3990  ,  17.8919  ,  18.3317  ,   0.0     ,   0.0     /
      DATA CST /
     *   0.0     ,  22.9276  ,  0.0      , 0.0       ,  0.0      ,
     *   0.0     ,  0.0      ,   0.0     ,   0.0     ,   0.230600,
     *   0.0     ,   0.0     ,  0.0      ,   0.0     ,   0.0     ,
     *   0.0     ,  0.0      ,  43.8983  , 213.187   ,  85.7484  ,
     * 136.108   ,  35.6338  ,  26.8938  ,  20.2626  ,  17.8674  ,
     *  15.3535  ,  13.5359  ,  12.1763  ,  11.3966  ,  10.3163  ,
     *  10.7805  ,  11.4468  ,  12.9479  ,  15.2372  ,   0.260900,
     *   0.226100,   0.274800,   0.166400,   0.125599,   0.117622,
     *   0.204785,  11.0040  ,  21.5707  ,  24.7997  ,  25.8749  ,
     *  25.2052  ,  24.6605  ,  24.7008  ,  25.8499  ,  26.8909  ,
     *  27.9074  ,  28.5284  ,  27.7660  ,  26.4659  ,  24.3879  ,
     *  20.2073  ,  18.7726  ,  17.6083  ,  16.7669  ,  15.8850  ,
     *  15.1009  ,  14.3996  ,  13.7546  ,  12.9331  ,  12.6648  ,
     *  12.1899  ,  11.4407  ,  11.3604  ,  10.9975  ,  10.6647  ,
     *   0.261033,   0.275116,   0.295977,   0.321703,   0.350500,
     *   0.382661,   0.417916,   0.424593,   1.48260 ,   1.57290 ,
     *   1.96347 ,   8.61800 ,   8.79370 ,   9.55642 ,  11.3824  ,
     *  14.0422  ,  23.1052  ,  19.9887  ,  18.5990  ,  17.8309  ,
     *  16.9235  ,  16.0927  ,  15.3622  ,  14.9455  ,  14.3136  ,
     *  13.4346  ,  12.8946  ,  12.4044  ,   0.0     ,   0.0     /
      DATA DLT /
     *   0.0     ,   0.178000,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   1.12510 ,
     *   0.0     ,   0.0     ,   0.0     ,   0.0     ,   0.0     ,
     *   0.0     ,   0.0     ,   1.64420 ,   0.865900,   1.02110 ,
     *   1.46800 ,   1.90210 ,   2.05710 ,   1.49220 ,   2.24410 ,
     *   2.30450 ,   2.34880 ,   2.38000 ,   1.67350 ,   2.41000 ,
     *   2.96230 ,   3.68300 ,   4.27790 ,   4.35430 ,   3.98510 ,
     *   3.53750 ,   1.52920 ,   2.66940 ,   3.26588 ,   3.65721 ,
     *   3.53346 ,   3.74290 ,   2.71263 ,   1.56756 ,   1.28918 ,
     *   0.605844,   1.04630 ,   1.60290 ,   2.03960 ,   2.46630 ,
     *   2.68270 ,   2.52390 ,   2.27350 ,   1.99000 ,   1.49530 ,
     *   2.69590 ,   3.28719 ,   3.33049 ,   2.82428 ,   2.85137 ,
     *   2.87516 ,   2.89604 ,   2.92270 ,   3.54545 ,   2.95354 ,
     *   2.96577 ,   3.63837 ,   2.98233 ,   2.98706 ,   2.98963 ,
     *   3.71601 ,   4.30013 ,   4.76492 ,   5.11982 ,   5.44174 ,
     *   5.67589 ,   5.83377 ,   5.78370 ,   5.86000 ,   5.96760 ,
     *   5.52593 ,   5.96960 ,   6.46920 ,   7.02588 ,   7.42518 ,
     *   7.44330 ,   2.11253 ,   3.21097 ,   4.08655 ,   4.80703 ,
     *   4.17287 ,   4.18800 ,   4.18550 ,   3.47947 ,   3.49331 ,
     *   4.21665 ,   4.23284 ,   4.24391 ,   0.0     ,   0.0     /
      DATA DST /
     *  0.0      ,   0.982100, 0.0       ,   0.0     ,   0.0     ,
     *  0.0      ,   0.0     ,  0.0      ,  0.0      ,  21.7184  ,
     * 0.0       ,   0.0     ,  0.0      ,  0.0      ,  0.0      ,
     *  0.0      ,  0.0      ,  33.3929  ,  41.6841  , 178.437   ,
     *  51.3531  , 116.105   , 102.478   ,  98.7399  ,  83.7543  ,
     *  76.8805  ,  71.1692  ,  66.3421  ,  64.8126  ,  58.7097  ,
     *  61.4135  ,  54.7625  ,  47.7972  ,  43.8163  ,  41.4328  ,
     *  39.3972  , 164.934   , 132.376   , 104.354   ,  87.6627  ,
     *  69.7957  ,  61.6584  ,  86.8472  ,  94.2928  ,  98.6062  ,
     *  76.8986  ,  99.8156  ,  87.4825  ,  92.8029  ,  83.9571  ,
     *  75.2825  ,  70.8403  ,  66.8776  ,  64.2658  , 213.904   ,
     * 167.202   , 133.124   , 127.113   , 143.644   , 137.903   ,
     * 132.721   , 128.007   , 123.174   , 101.398   , 115.362   ,
     * 111.874   ,  92.6566  , 105.703   , 102.961   , 100.417   ,
     *  84.3298  ,  72.0290  ,  63.3644  ,  57.0560  ,  52.0861  ,
     *  48.1647  ,  45.0011  ,  38.6103  ,  36.3956  ,  38.3246  ,
     *  45.8149  ,  47.2579  ,  48.0093  ,  47.0045  ,  45.4715  ,
     *  44.2473  , 150.645   , 142.325   , 117.020   ,  99.1722  ,
     * 105.251   , 100.613   ,  97.4908  , 105.980   , 102.273   ,
     *  88.4834  ,  86.0030  ,  83.7881  ,   0.0     ,   0.0     /
      DATA ELT /
     *   0.008   ,   0.006400,   0.3747  ,   0.7163  ,   1.243   ,
     *   1.412   ,  1.498    ,   1.578   ,   1.668   ,   0.351500,
     *   2.216   ,   2.291   ,   2.491   ,   2.801   ,   3.343   ,
     *   4.073   ,   4.839   ,   1.44450 ,   1.42280 ,   1.37510 ,
     *   1.33290 ,   1.28070 ,   1.21990 ,   1.18320 ,   1.08960 ,
     *   1.03690 ,   1.01180 ,   1.03410 ,   1.19100 ,   1.30410 ,
     *   1.71890 ,   2.13130 ,   2.53100 ,   2.84090 ,   2.95570 ,
     *   2.82500 ,   3.48730 ,   2.50640 ,   1.91213 ,   2.06929 ,
     *   3.75591 ,   4.38750 ,   5.40428 ,   5.37874 ,   5.32800 ,
     *   5.26593 ,   5.17900 ,   5.06940 ,   4.93910 ,   4.78210 ,
     *   4.59090 ,   4.35200 ,   4.07120 ,   3.71180 ,   3.33520 ,
     *   2.77310 ,   2.14678 ,   1.86264 ,   2.05830 ,   1.98486 ,
     *   2.02876 ,   2.20963 ,   2.57450 ,   2.41960 ,   3.58324 ,
     *   4.29728 ,   4.56796 ,   5.92046 ,   6.75621 ,   7.56672 ,
     *   7.97628 ,   8.58154 ,   9.24354 ,   9.88750 ,  10.4720  ,
     *  11.0005  ,  11.4722  ,  11.6883  ,  12.0658  ,  12.6089  ,
     *  13.1746  ,  13.4118  ,  13.5782  ,  13.6770  ,  13.7108  ,
     *  13.6905  ,  13.7247  ,  13.6211  ,  13.5266  ,  13.4314  ,
     *  13.4287  ,  13.3966  ,  13.3573  ,  13.3812  ,  13.3592  ,
     *  13.2887  ,  13.2754  ,  13.2674  ,   0.0     ,   0.0     /

      DATA N1/8,805,1209,205,2,3,14,15,6,1405,1401,1307,112,1909, 
     1 16,19,312,107,11,301,1903,2009,22,318,1314,605,315,1409,321,
     2 2614,701,705,119,1905,218,1118,1802,1918,25,2618,1402,1317,
     3 2003,1821,1808,1604,107,304,914,1914,1902,2005,9,2405,319,
     4 201,1201,305,1618,1404,1613,1913,521,704,2002,425,815,518,
     5 2013,2502,1921,806,2001,23,1805,1519,918,1620,121,807,2012,
     6 1602,209,1615,120,1814,618,1801,103,2008,1601,21,1416,1621,
     7 113,313,211,306,519,613/
C
C**** ATOMIC SCATTERING FACTORS FOR ABOVE ATOM TYPES 
C****     F=AL*EXP(-AS*RHO)+BL*EXP(-BS*RHO)+CL*EXP(-CS*RHO)+
C    + DL*EXP(-DS*RHO)+EL
      DO 150 I=1,NK                                                     07250000
C
C**** CHECK ATOM TYPE                                                   07260001
C CHANGED TO INT. TABLES EXPRESIONS
C
      DO 120 J=1,100                                                    07270000
      IF(NW(I).NE.N1(J)) GO TO 120                                      07280000
      AS(I)=AST(J)                                                      07290000
      AL(I)=ALT(J)                                                      07300000
      BS(I)=BST(J)                                                      07310000
      BL(I)=BLT(J)                                                      07320000
      CL(I)=CLT(J)                                                      07330000
      CS(I)=CST(J)
      DL(I)=DLT(J)
      DS(I)=DST(J)
      EL(I)=ELT(J)
      GO TO 150
  120 CONTINUE                                                          07340000
  150 CONTINUE                                                          07350000
      RETURN                                                            07360000
      END                                                               07370000
C**** ------------------------------------------------------------------07380001
C**** CALCULATE SCATTERING FACTORS FOR RANDOM GROUPS  (NINF = 2)        07390001
      SUBROUTINE DEBYE(NMEM,NTOT,CR,POP)                                07400000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    07410000
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           07430000
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF                             07440000
      DIMENSION G(142),CR(9)                                            07450000
      FP=4.0*PI                                                         07460000
      IF(CR(1).LT.0.01) GO TO 15                                        07470000
      WRITE(LO,5) (CR(I),I=1,6)                                         07480000
    5 FORMAT(36H GIVEN COORDINATES REFER TO THE CELL,2X,4H A =,F6.2,    07490000
     1 2X,3HB =,F6.2,2X,3HC =,F6.2,2X,7HALPHA =,F6.1,2X,6HBETA =,       07500000
     2 F6.1,2X,7HGAMMA =,F6.1)                                          07510000
C**** CONVERT TO ORTHOGONAL COORDINATES                                 07520001
      CALL VOL(CR,V)                                                    07530000
      R1=CR(3)*(CR(4)-CR(5)*CR(6))/CR(9)                                07540000
      R2=CR(3)*V/CR(9)                                                  07550000
      DO 10 I=NMEM,NTOT                                                 07560000
      X(I)=CR(1)*X(I)+CR(2)*CR(6)*Y(I)+CR(3)*CR(5)*Z(I)                 07570000
      Y(I)=CR(2)*CR(9)*Y(I)+R1*Z(I)                                     07580000
      Z(I)=R2*Z(I)                                                      07590000
   10 CONTINUE                                                          07600000
   15 D=1.0                                                             07610000
      DO 100 I=1,142                                                    07620000
      G(I)=0.0                                                          07630000
      T=0.01*FLOAT(I-1)                                                 07640000
      TT=T*T                                                            07650000
      DO 20 J=1,NK                                                      07660000
C     F(J)=AL(J)*EXP(-AS(J)*TT)+BL(J)*EXP(-BS(J)*TT)+CL(J)
C
C  CHANGED TO Int. Tables approximation
C
      F(J)=AL(J)*EXP(-AS(J)*TT)+BL(J)*EXP(-BS(J)*TT)+CL(J)*EXP(-CS(J)
     1 *TT)+DL(J)*EXP(-DS(J)*TT)+EL(J)
   20 CONTINUE                                                          07680000
C**** SUM OVER INTERATOMIC VECTORS                                      07690001
      DO 50 K=NMEM,NTOT                                                 07700000
      KT=NZ(K)                                                          07710000
      NT=K+1                                                            07720000
      G(I)=G(I)+F(KT)*F(KT)                                             07730000
      IF(K.EQ.NTOT) GO TO 50                                            07740000
      DO 40 L=NT,NTOT                                                   07750000
      LT=NZ(L)                                                          07760000
      IF(I.EQ.1) GO TO 30                                               07770000
      D=FP*T*SQRT((X(K)-X(L))**2+(Y(K)-Y(L))**2+(Z(K)-Z(L))**2)         07780000
      D=SIN(D)/D                                                        07790000
   30 G(I)=G(I)+2.0*F(KT)*F(LT)*D                                       07800000
   40 CONTINUE                                                          07810000
   50 CONTINUE                                                          07820000
      G(I)=SQRT(G(I))                                                   07830000
  100 CONTINUE                                                          07840000
      WRITE(LO,120) (G(I),I=1,101,2)                                    07850000
  120 FORMAT(1H0,26X,66HGROUP SCATTERING FACTORS AT INTERVALS OF 0.02 IN07860000
     1 SIN(THETA)/LAMBDA/(1H ,17F7.2))                                  07870000
      DO 140 I=1,142                                                    07880000
      GIS(I)=GIS(I)+G(I)*G(I)*POP                                       07890000
  140 CONTINUE                                                          07900000
      RETURN                                                            07910000
      END                                                               07920000
C**** ------------------------------------------------------------------07930001
C**** USER SUPPLIED SUBROUTINE TO READ IN LOCAL STANDARD TAPE           07940001
C**** THE SUPPLIED SUBROUTINE READS THE YORK DATA TAPE                  07950001
      SUBROUTINE TAPEIN                                                 07960000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    07970000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       07980000
     1 RHO(60),SIG(60)                                                  07990000
      DIMENSION IKL(60),F(60),SIGMA(60)                                 08000000
      REWIND ISTAN                                                      08010000
      K=0                                                               08020000
C**** READ YORK DATA TAPE                                               08030001
   10 READ(ISTAN) IKL,F,SIGMA,SIGMA                                     08040000
C**** FILL ARRAYS LH, LK, LL, FO AND SIG WITH 60 REFLEXIONS             08050001
      DO 20 I=1,60                                                      08060000
      K=K+1                                                             08070000
      FO(K)=-1.0                                                        08080000
C**** TAPE ENDS WITH REFLEXION 000 (IKL = 32896)                        08090001
      IF(IKL(I).EQ.32896) GO TO 30                                      08100000
C**** UNPACK IKL                                                        08110001
      IND=IKL(I)                                                        08120000
      LH(K)=IND/65536                                                   08130000
      IF(IND.LT.0) LH(K)=LH(K)-1                                        08140000
      IND=IND-65536*LH(K)                                               08150000
      LK(K)=IND/256                                                     08160000
      LL(K)=IND-256*LK(K)-128                                           08170000
      LK(K)=LK(K)-128                                                   08180000
      FO(K)=F(I)                                                        08190000
C**** SIG .LT. 0.0 FOR UNOBSERVED REFLEXIONS                            08200001
      SIG(K)=SIGMA(I)                                                   08210000
      IF(K.NE.60) GO TO 20                                              08220000
C**** CALCULATE RHO, EPSILON, MULTIPLICITY, SCATTERING FACTOR AND       08230001
C**** CREATE SCRATCH FILE                                               08240001
      CALL FCAL                                                         08250000
      K=0                                                               08260000
   20 CONTINUE                                                          08270000
      GO TO 10                                                          08280000
   30 CALL FCAL                                                         08290000
      RETURN                                                            08300000
      END                                                               08310000
C**** ------------------------------------------------------------------08320001
C**** READ REFLEXIONS FROM CARD INPUT                                   08330001
      SUBROUTINE CARDIN                                                 08340000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    08350000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       08360000
     1 RHO(60),SIG(60)                                                  08370000
      DIMENSION IFORM(20),KH(12),KK(12),KL(12),F(12),KD(12)             08380000
      READ(LN,5) IFORM                                                  08390000
    5 FORMAT(20A4)                                                      08400000
      K=0                                                               08410000
      NN=IABS(NPC)                                                      08420000
   10 READ(LN,IFORM,END=30) (KH(I),KK(I),KL(I),F(I),KD(I),I=1,NN)
      DO 20 I=1,NN                                                      08440000
      K=K+1                                                             08450000
      LH(K)=KH(I)                                                       08460000
      LK(K)=KK(I)                                                       08470000
      LL(K)=KL(I)                                                       08480000
      FO(K)=F(I)                                                        08490000
      SIG(K)=FLOAT(1-2*KD(I))                                           08500000
      IF(F(I).LT.0.0) GO TO 30                                          08510000
      IF(K.NE.60) GO TO 20                                              08520000
C**** CALCULATE RHO, EPSILON, MULTIPLICITY, SCATTERING FACTOR AND       08530001
C**** CREATE SCRATCH FILE                                               08540001
      CALL FCAL                                                         08550000
      K=0                                                               08560000
   20 CONTINUE                                                          08570000
      GO TO 10                                                          08580000
   30 CALL FCAL                                                         08590000
      RETURN                                                            08600000
      END                                                               08610000
C**** ------------------------------------------------------------------08620001
C**** CALCULATE RHO, EPSILON, MULTIPLICITY AND SCATTERING FACTOR        08630001
C**** FOR EACH REFLEXION AND CREATE THE SCRATCH TAPE (ISCRA)            08640001
C**** PREPARE FILE FOR WEIGHTED FOURIER                                 08650001
      SUBROUTINE FCAL                                                   08660000
      DIMENSION I1(3),I2(3)                                             08670000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    08680000
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT,LATB      08690000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       08700000
     1 RHO(60),SIG(60)                                                  08710000
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           08720000
      COMMON/AT/GIS(142),GIW(142),NGP,NDIFF                             08730000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        08740000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS08750000
C**** BESSEL FUNCTION I1/I0                                             08760001
      VEC(U)=U*(U+0.4807)/((U+0.8636)*U+1.3943)                         08770000
      DO 300 I=1,60                                                     08780000
      IF(FO(I).LT.0.0) GO TO 310                                        08790000
      NREF=NREF+1                                                       08800000
      RHO(I)=P(1)*FLOAT(LH(I)*LH(I))+P(2)*FLOAT(LK(I)*LK(I))            08810000
     1 +P(3)*FLOAT(LL(I)*LL(I))+P(4)*FLOAT(LH(I)*LK(I))                 08820000
     2 +P(5)*FLOAT(LH(I)*LL(I))+P(6)*FLOAT(LK(I)*LL(I))                 08830000
      RHOMAX=AMAX1(RHOMAX,RHO(I))                                       08840000
C**** COMPUTE EPSILON AND MULTIPLICITY BY GENERATING EQUIVALENT         08850001
C**** REFLEXIONS                                                        08860001
C**** EPSILON = NUMBER OF TIMES SAME REFLEXION APPEARS IN LIST          08870001
C**** MULTIPLICITY = NUMBER DIFFERENT REFLEXIONS IN LIST                08880001
      EPS=1.0                                                           08890000
      MULT=1                                                            08900000
      I1(1)=LH(I)                                                       08910000
      I1(2)=LK(I)                                                       08920000
      I1(3)=LL(I)                                                       08930000
C**** IN TRICLINIC SPACE GROUPS EPS = 1.0 AND MULT = 1                  08940001
      IF(NSYM.EQ.1) GO TO 60                                            08950000
      K1=65536*I1(1)+256*(I1(2)+128)+I1(3)+128                          08960000
      IK1=65792-K1                                                      08970000
      DO 50 J=2,NSYM                                                    08980000
      DO 10 L=1,3                                                       08990000
   10 I2(L)=0                                                           09000000
      DO 40 L=1,3                                                       09010000
      DO 30 K=1,2                                                       09020000
      M=IABS(IS(K,L,J))                                                 09030000
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))                   09040000
   30 CONTINUE                                                          09050000
   40 CONTINUE                                                          09060000
      K2=65536*I2(1)+256*(I2(2)+128)+I2(3)+128                          09070000
      IF(K2.EQ.K1) EPS=EPS+1.0                                          09080000
      IF(ICENT.NE.0.AND.K2.EQ.IK1) EPS=EPS+1.0                          09090000
      IF(K2.EQ.K1.OR.K2.EQ.IK1) MULT=MULT+1                             09100000
   50 CONTINUE                                                          09110000
   60 FF=FO(I)*FO(I)/PTS                                                09120000
      ID(I)=NSYM/MULT                                                   09130000
C**** DETERMINE INDEX GROUP (FOR RESCALING)                             09140001
      IF(KSYS.GE.7) GO TO 90                                            09150000
      LG=MOD(IABS(LL(I)),2)                                             09160000
      IF(KSYS.GE.5) GO TO 80                                            09170000
      KG=MOD(IABS(LK(I)),2)                                             09180000
      JG=MOD(IABS(LH(I)),2)                                             09190000
C**** TRICLINIC, MONCLINIC AND ORTHORHOMBIC                             09200001
      IF(KSYS.LE.3) IG=JG+2*KG+4*LG                                     09210000
C**** TETRAGONAL                                                        09220001
      IF(KSYS.EQ.4) IG=JG+KG+3*LG                                       09230000
      GO TO 100                                                         09240000
C**** TRIGONAL, HEXAGONAL AND RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES    09250001
   80 IG=3*LG                                                           09260000
      IF(MOD(LH(I),3).EQ.0) IG=IG+1                                     09270000
      IF(MOD(LK(I),3).EQ.0.OR.MOD(LH(I)+LK(I),3).EQ.0) IG=IG+1          09280000
      GO TO 100                                                         09290000
C**** CUBIC AND PRIMITIVE RHOMBOHEDRAL                                  09300001
   90 IG=3*MOD(IABS(LH(I)+LK(I)+LL(I)),2)                               09310000
      IF(MOD(LH(I)-LL(I),3).EQ.0) IG=IG+1                               09320000
      IF(MOD(LK(I)-LL(I),3).EQ.0.OR.MOD(LH(I)-LK(I),3).EQ.0) IG=IG+1    09330000
C**** PACK SYMMETRY FUNCTIONS FOR LATER USE                             09340001
  100 ID(I)=10000*ID(I)+100*INT(EPS+0.5)+IG+1                           09350000
C**** LOOK UP SCATTERING FACTOR TABLES GENERATED BY ATREC               09360001
      SINTH=100.0*SQRT(RHO(I))                                          09370000
      IND=MAX0(2,INT(SINTH+1.5))                                        09380000
      FRAC=SINTH-FLOAT(IND-1)                                           09390000
      BF=0.5*(GIW(IND+1)-GIW(IND-1))                                    09400000
      AF=BF+GIW(IND-1)-GIW(IND)                                         09410000
      FORM=AF*FRAC*FRAC+BF*FRAC+GIW(IND)                                09420000
C**** 'WILSON' STRUCTURE FACTOR                                         09430001
      EW(I)=FF/(FORM*EPS)                                               09440000
      BF=0.5*(GIS(IND+1)-GIS(IND-1))                                    09450000
      AF=BF+GIS(IND-1)-GIS(IND)                                         09460000
      FORM=AF*FRAC*FRAC+BF*FRAC+GIS(IND)                                09470000
C**** 'DEBYE' STRUCTURE FACTOR                                          09480001
      ED(I)=FF/(FORM*EPS)                                               09490000
      IF(IK.EQ.-1) ED(I)=FF                                             09500000
      IF(NDIFF.NE.1) GO TO 300                                          09510000
      NS=1                                                              09520000
C**** PHASES FOR WEIGHTED E-MAP                                         09530001
      DO 110 IGP=1,NGP                                                  09540000
      NF=NS+NAG(IGP)-1                                                  09550000
      IF(NINF(IGP).GT.5) GO TO 120                                      09560000
      NS=NF+1                                                           09570000
  110 CONTINUE                                                          09580000
  120 REL=0.0                                                           09590000
      RIM=0.0                                                           09600000
      IENT=0                                                            09610000
      DO 160 J=1,NSYM                                                   09620000
      T=1000.0                                                          09630000
      DO 130 L=1,3                                                      09640000
      T=T+FLOAT(I1(L))*TS(L,J)                                          09650000
      I2(L)=0                                                           09660000
  130 CONTINUE                                                          09670000
      DO 150 L=1,3                                                      09680000
      DO 140 K=1,2                                                      09690000
      M=IABS(IS(K,L,J))                                                 09700000
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))                   09710000
  140 CONTINUE                                                          09720000
  150 CONTINUE                                                          09730000
      CALL SFAC(NS,NF,I2,T,RHO(I),A,B,IENT)                             09740000
      IENT=1                                                            09750000
      REL=REL+A                                                         09760000
      IF(ICENT.EQ.0) RIM=RIM+B                                          09770000
      IF(ICENT.EQ.1) REL=REL+A                                          09780000
  160 CONTINUE                                                          09790000
C**** SIM WEIGHTING SCHEME                                              09800001
      FCL=PTS*SQRT(REL*REL+RIM*RIM)                                     09810000
      SIG(I)=FCL*EXP(-BT*RHO(I))                                        09820000
      XKAP=2.0*SC*FO(I)*SIG(I)/FORM                                     09830000
      IF (ICENT.EQ.0) WATE = VEC(XKAP)                                  09840000
      IF (ICENT.EQ.1) WATE = TANH(XKAP/2.0)                             09850000
      FOBS = SC * EXP(BT * RHO(I)) * FO(I)                              09860000
      COEFF = 0.0                                                       09870000
      IF (FCL.LT.0.00001) GOTO 200                                      09880000
      IF (NINF(IGP).EQ.6) COEFF = FOBS * WATE / FCL                     09890000
      IF (NINF(IGP).EQ.7) COEFF = (FOBS * WATE - FCL) / FCL             09900000
  200 EW(I)=REL*COEFF                                                   09910000
      ED(I)=RIM*COEFF                                                   09920000
      EN=EN+SIG(I)                                                      09930000
      ER=ER+FO(I)                                                       09940000
  300 CONTINUE                                                          09950000
      I=60                                                              09960000
C**** CREATE SCRATCH TAPE                                               09970001
  310 IF(NDIFF.EQ.0) WRITE(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG          09980000
C**** CREATE FILE FOR WEIGHTED FOURIER                                  09990001
      IF(FO(I).LT.0.0) LH(I)=-1000                                      10000000
      IF(NDIFF.EQ.1) WRITE(ISCRA) LH,LK,LL,EW,ED,FO,SIG                 10010000
      RETURN                                                            10020000
      END                                                               10030000
C**** ------------------------------------------------------------------10040001
C**** STRUCTURE FACTOR CALCULATION                                      10050001
      SUBROUTINE SFAC(NS,NF,L,T,RHO,A,B,IENT)                           10060000
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           10080000
      COMMON/TRIG/SINT(450)                                             10090000
      DIMENSION L(3),COST(360)                                          10100000
      EQUIVALENCE (SINT(91),COST(1))                                    10110000
      A=0.0                                                             10120000
      B=0.0                                                             10130000
      IF(IENT.EQ.1) GO TO 30                                            10140000
      DO 10 I=1,NK                                                      10150000
      F(I)=AL(I)*EXP(-AS(I)*RHO)+BL(I)*EXP(-BS(I)*RHO)+CL(I)*EXP(-CS(I)
     1*RHO)+DL(I)*EXP(-DS(I)*RHO)+EL(I)
   10 CONTINUE                                                          10170000
   30 HJ=FLOAT(L(1))                                                    10180000
      HK=FLOAT(L(2))                                                    10190000
      HL=FLOAT(L(3))                                                    10200000
      DO 50 I=NS,NF                                                     10210000
      N=NZ(I)                                                           10220000
      ARG=AMOD(HJ*X(I)+HK*Y(I)+HL*Z(I)+T,1.0)                           10230000
      IARG=INT(360.0*ARG+0.5)+1                                         10240000
      IF(IARG.EQ.361) IARG=1                                            10250000
      A=A+F(N)*COST(IARG)                                               10260000
      B=B+F(N)*SINT(IARG)                                               10270000
   50 CONTINUE                                                          10280000
      RETURN                                                            10290000
      END                                                               10300000
C**** ------------------------------------------------------------------10310001
C**** LEAST SQUARES PLOT, INCLUDING SUMMATION OVER NB RANGES OF RHO     10320001
      SUBROUTINE SUM(PTS)                                               10330000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    10340000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       10350000
     1 RHO(60),SIG(60)                                                  10360000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        10370000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS10380000
      DIMENSION SW(30),SD(30),SR(30),SI(30),NSUM(30)                    10390000
      WRITE(LO,40)                                                      10400000
   40 FORMAT(//1H0,20X,18HLEAST SQUARES PLOT//6H RANGE,6X,              10410000
     1 18HRHO=(SINTH/LAM)**2,6X,6HNUMBER,6X,8HMEAN RHO,7X,6HMEAN I,     10420000
     2 7X,23HMEAN EXP(-2*B*RHO)*E**2,3X,5HDEBYE,7X,6HWILSON)            10430000
C**** SET INITIAL VALUES                                                10440001
      PP=0.0                                                            10450000
      Q=0.0                                                             10460000
      R=0.0                                                             10470000
      S=0.0                                                             10480000
      T=0.0                                                             10490000
      NUMBER=0                                                          10500000
      ADD=RHOMAX/FLOAT(NB)                                              10510000
      START=-ADD                                                        10520000
      END=ADD                                                           10530000
      RR=FLOAT(NB)/RHOMAX                                               10540000
      DO 50 I=1,30                                                      10550000
      SW(I)=0.0                                                         10560000
      SD(I)=0.0                                                         10570000
      SR(I)=0.0                                                         10580000
      SI(I)=0.0                                                         10590000
      NSUM(I)=0                                                         10600000
   50 CONTINUE                                                          10610000
      REWIND ISCRA                                                      10620000
C**** READ SCRATCH TAPE                                                 10630001
  100 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG                          10640000
      DO 200 I=1,60                                                     10650000
C**** TAPE ENDS WITH FO .LT. 0.0                                        10660001
      IF(FO(I).LT.0.0) GO TO 250                                        10670000
C**** N STORES RANGE OF RHO                                             10680001
      N=MIN0(INT(1.0+RR*RHO(I)),NB)                                     10690000
      MULT=ID(I)/10000                                                  10700000
      IE=(ID(I)-10000*MULT)/100                                         10710000
      EPS=FLOAT(IE)                                                     10720000
      TMUL=FLOAT(MULT)                                                  10730000
C**** WEIGHTED SUMS                                                     10740001
C**** NUMBER OF REFLEXIONS                                              10750001
      NSUM(N)=NSUM(N)+MULT                                              10760000
C**** WILSON                                                            10770001
      SW(N)=SW(N)+EW(I)*TMUL                                            10780000
C**** DEBYE                                                             10790001
      SD(N)=SD(N)+ED(I)*TMUL                                            10800000
C**** RHO                                                               10810001
      SR(N)=SR(N)+RHO(I)*TMUL                                           10820000
C**** INTENSITY                                                         10830001
      SI(N)=SI(N)+TMUL*FO(I)*FO(I)/(EPS*PTS)                            10840000
  200 CONTINUE                                                          10850000
      GO TO 100                                                         10860000
  250 DO 300 I=1,NB                                                     10870000
C**** SMOOTH CURVE BY ADDING ADJACENT RANGES                            10880001
      NUMBER=NUMBER+NSUM(I)                                             10890000
      NSUM(I)=NSUM(I)+NSUM(I+1)                                         10900000
      SW(I)=SW(I)+SW(I+1)                                               10910000
      SD(I)=SD(I)+SD(I+1)                                               10920000
      SR(I)=SR(I)+SR(I+1)                                               10930000
      SI(I)=SI(I)+SI(I+1)                                               10940000
C**** CALCULATE WEIGHTED AVERAGES AND LOGS                              10950001
      WT=FLOAT(NSUM(I))                                                 10960000
      DIV=1.0/AMAX1(1.0,WT)                                             10970000
      ESQAV=SD(I)*DIV                                                   10980000
      FLGD(I)=ALOG(ESQAV)                                               10990000
      AVI=SI(I)*DIV                                                     11000000
      AVR(I)=SR(I)*DIV                                                  11010000
      FLGW(I)=ALOG(SW(I)*DIV)                                           11020000
      START=START+ADD                                                   11030000
      END=AMIN1(END+ADD,RHOMAX)                                         11040000
      WRITE(LO,280) I,START,END,NSUM(I),AVR(I),AVI,ESQAV,FLGD(I),FLGW(I)11050000
  280 FORMAT(1H ,I3,F15.4,3H  -,F8.4,I11,F14.4,F14.1,F23.4,F15.4,F13.4) 11060000
C**** COEFFICIENTS OF NORMAL EQUATIONS                                  11070001
      PP=PP+WT*AVR(I)*AVR(I)                                            11080000
      Q=Q+WT*AVR(I)                                                     11090000
      R=R+WT*AVR(I)*FLGD(I)                                             11100000
      S=S+WT*FLGD(I)                                                    11110000
      T=T+WT                                                            11120000
  300 CONTINUE                                                          11130000
      WRITE(LO,320) PP,Q,R,Q,T,S                                        11140000
  320 FORMAT(17H0NORMAL EQUATIONS/(1H ,E11.3,10H * SLOPE +,E11.3,       11150000
     1 14H * INTERCEPT =,E11.3))                                        11160000
C**** LEAST SQUARES                                                     11170001
      DIV=PP*T-Q*Q                                                      11180000
      SLOPE=(R*T-Q*S)/DIV                                               11190000
      FLGK=(PP*S-Q*R)/DIV                                               11200000
      SC=EXP(-FLGK)                                                     11210000
      BT=-0.5*SLOPE                                                     11220000
      WRITE(LO,340) SLOPE,FLGK,BT,SC                                    11230000
  340 FORMAT(1H0,7HSLOPE =,F8.4,4X,11HINTERCEPT =,F8.4,4X,              11240000
     1 24HTEMPERATURE FACTOR (B) =,F8.4,4X,7HSCALE =,F8.4/              11250000
     2 51X,37HF(ABSOLUTE)**2 = SCALE*F(OBSERVED)**2)                    11260000
      RETURN                                                            11270000
      END                                                               11280000
C**** ------------------------------------------------------------------11290001
C**** LINE PRINTER PLOT AT 50 VALUES OF RHO                             11300001
      SUBROUTINE GRAPH(NGP)                                             11310000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    11320000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        11330000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS11340000
      DIMENSION FH(6),RH(6),M(117),R(4),AD(4),AW(4)                     11350000
      DATA IST,ISP,ICW,ICD/1H*,1H ,1HW,1HD/                             11360000
C**** DETERMINE RANGES OF LOGS                                          11370001
      RX=AVR(NB)                                                        11380000
      FX=FLGK                                                           11390000
      FN=SLOPE*RX+FLGK                                                  11400000
      DO 10 I=1,117                                                     11410000
      M(I)=ISP                                                          11420000
   10 CONTINUE                                                          11430000
      DO 20 I=1,NB                                                      11440000
      FX=AMAX1(FX,FLGW(I),FLGD(I))                                      11450000
      FN=AMIN1(FN,FLGW(I),FLGD(I))                                      11460000
   20 CONTINUE                                                          11470000
      FD=FX-FN                                                          11480000
      DO 30 I=1,6                                                       11490000
      RH(I)=0.2*FLOAT(I-1)*RX                                           11500000
      FH(I)=FN+0.2*FLOAT(I-1)*FD                                        11510000
   30 CONTINUE                                                          11520000
C**** TOP FRAME                                                         11530001
      WRITE(LO,40) ITLE,FH,RH(1)                                        11540000
   40 FORMAT(1H1,25X,63HPLOT OF WILSON AND DEBYE CURVES AND LEAST SQUARE11550000
     1S STRAIGHT LINE/1H0,15X,20A4/1H0,40X,20HLN(F(OBS)**2/SIGFSQ)/1H , 11560000
     2 F18.3,5F20.3/1H ,F12.3,2X,1H-,5(1HI,19(1H-)),2HI-)               11570000
      J=1                                                               11580000
      IR=2                                                              11590000
      DO 200 I=1,50                                                     11600000
      DCV(I)=-1000000.0                                                 11610000
C**** SIDE FRAME                                                        11620001
      IF(MOD(I,10).EQ.0) GO TO 60                                       11630000
      WRITE(LO,50)                                                      11640000
   50 FORMAT(1H ,15X,1HI)                                               11650000
      GO TO 80                                                          11660000
   60 WRITE(LO,70) RH(IR)                                               11670000
   70 FORMAT(1H ,F11.3,3X,3H-I-)                                        11680000
      IR=IR+1                                                           11690000
C**** INTERPOLATION                                                     11700001
   80 Q=0.02*FLOAT(I)*RX                                                11710000
      IL=(SLOPE*Q+FLGK-FN)*100.0/FD+16.5                                11720000
      IF(IL.GT.117) IL=117                                              11730000
      IF(IL.LT.1) IL=1                                                  11740000
      M(IL)=IST                                                         11750000
C**** STRAIGHT LINE OUTPUT (*)                                          11760001
      WRITE(LO,170) (M(L),L=1,IL)                                       11770000
      M(IL)=ISP                                                         11780000
      IF(Q.LT.AVR(1)) GO TO 180                                         11790000
      IF(J.EQ.1) GO TO 90                                               11800000
      IF(J.EQ.NB-2) GO TO 130                                           11810000
      IF(Q.LT.AVR(J+1)) GO TO 130                                       11820000
   90 J=J+1                                                             11830000
      DO 100 K=1,4                                                      11840000
      ITEMP = J-2+K                                                     11850000
      R(K)=AVR(ITEMP)                                                   11860000
  100 CONTINUE                                                          11870000
      CALL SOLVE(R,FLGW(J-1),FLGW(J),FLGW(J+1),FLGW(J+2),AW)            11880000
      IF(NGP.EQ.0) GO TO 130                                            11890000
      CALL SOLVE(R,FLGD(J-1),FLGD(J),FLGD(J+1),FLGD(J+2),AD)            11900000
C**** WILSON PLOT INTERPOLATION                                         11910001
  130 IL=100.0*(AW(4)+Q*(AW(3)+Q*(AW(2)+Q*AW(1)))-FN)/FD+16.5           11920000
      IF(IL.GT.117) IL=117                                              11930000
      IF(IL.LT.1) IL=1                                                  11940000
      M(IL)=ICW                                                         11950000
C**** WILSON PLOT OUTPUT (W)                                            11960001
      WRITE(LO,170) (M(L),L=1,IL)                                       11970000
      M(IL)=ISP                                                         11980000
      IF(NGP.NE.0) GO TO 160                                            11990000
C**** STORE K-CURVE                                                     12000001
      IF(IK.EQ.1) DCV(I)=EXP(AW(4)+Q*(AW(3)+Q*(AW(2)+Q*AW(1))))         12010000
      GO TO 180                                                         12020000
C**** DEBYE CURVE INTERPOLATION                                         12030001
  160 IL=100.0*(AD(4)+Q*(AD(3)+Q*(AD(2)+Q*AD(1)))-FN)/FD+16.5           12040000
      IF(IL.GT.117) IL=117                                              12050000
      IF(IL.LT.1) IL=1                                                  12060000
      M(IL)=ICD                                                         12070000
C**** DEBYE CURVE OUTPUT (D)                                            12080001
      WRITE(LO,170) (M(L),L=1,IL)                                       12090000
  170 FORMAT(1H+,117A1)                                                 12100000
      M(IL)=ISP                                                         12110000
C**** STORE K-CURVE                                                     12120001
      IF(IK.EQ.1) DCV(I)=EXP(AD(4)+Q*(AD(3)+Q*(AD(2)+Q*AD(1))))         12130000
  180 IF(I.EQ.25) WRITE(LO,190)                                         12140000
  190 FORMAT(1H+,2X,3HRHO)                                              12150000
  200 CONTINUE                                                          12160000
C**** K-CURVE PARAMETERS                                                12170001
      DEL=50.0/AVR(NB)                                                  12180000
C**** K-CURVE FOLLOWS LEAST-SQUARES STRAIGHT LINE UNTIL THE DEBYE CURVE 12190001
C**** CROSSES IT.                                                       12200001
      J=0                                                               12210000
      JP=0                                                              12220000
      DO 250 I=1,50                                                     12230000
      SK=EXP(SLOPE*FLOAT(I)/DEL+FLGK)                                   12240000
      IF(DCV(I).LT.(-999999.0)) GO TO 240                               12250000
      JP=-1                                                             12260000
      IF(DCV(I).GT.SK) JP=1                                             12270000
      IF(J.EQ.(-JP)) GO TO 270                                          12280000
      J=JP                                                              12290000
  240 DCV(I)=SK                                                         12300000
  250 CONTINUE                                                          12310000
  270 RETURN                                                            12320000
      END                                                               12330000
C**** ------------------------------------------------------------------12340001
C**** FIT CURVE TO Y = A(1) * RHO**3 + A(2) * RHO**2 + A(3) * RHO + A(4)12350001
      SUBROUTINE SOLVE(R,Y1,Y2,Y3,Y4,A)                                 12360000
      DIMENSION R(4),A(4)                                               12370000
      B2=R(4)*(R(4)+R(1))                                               12380000
      B1=(Y4-Y1)/(R(4)-R(1))                                            12390000
      C31=(Y2-Y1)/(R(2)-R(1))-B1                                        12400000
      C32=(Y3-Y1)/(R(3)-R(1))-B1                                        12410000
      C11=R(2)*(R(2)+R(1))-B2                                           12420000
      C12=R(3)*(R(3)+R(1))-B2                                           12430000
      C21=R(2)-R(4)                                                     12440000
      C22=R(3)-R(4)                                                     12450000
      A(1)=(C31*C22-C32*C21)/(C22*C11-C12*C21)                          12460000
      A(2)=(C31-C11*A(1))/C21                                           12470000
      A(3)=B1-(R(4)*R(4)+R(1)*R(1)+R(4)*R(1))*A(1)-(R(4)+R(1))*A(2)     12480000
      A(4)=Y1-R(1)*(A(3)+R(1)*(A(2)+R(1)*A(1)))                         12490000
      RETURN                                                            12500000
      END                                                               12510000
C**** ------------------------------------------------------------------12520001
C**** INDEX GROUP RESCALING                                             12530001
      SUBROUTINE RESCA(KSYS,ISC,JUMP)                                   12540000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    12550000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       12560000
     1 RHO(60),SIG(60)                                                  12570000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        12580000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS12590000
      DIMENSION NG(8),SCS(8)                                            12600000
      TOT=0.0                                                           12610000
      NW=0                                                              12620000
      DO 10 I=1,8                                                       12630000
      SCS(I)=0.0                                                        12640000
      NG(I)=0                                                           12650000
   10 CONTINUE                                                          12660000
      REWIND ISCRA                                                      12670000
  100 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG                          12680000
      DO 250 I=1,60                                                     12690000
      IF(FO(I).LT.0.0) GO TO 300                                        12700000
      IF(IK.NE.1) ESQ=SC*ED(I)*EXP(BT*RHO(I))                           12710000
      IF(IK.EQ.1) CALL CURVK(ESQ,RHO(I),ED(I))                          12720000
C**** UNPACK SYMMETRY FUNCTIONS                                         12730001
      MULT=ID(I)/10000                                                  12740000
      TMUL=FLOAT(MULT)                                                  12750000
      TOT=TOT+ESQ*TMUL                                                  12760000
      NW=NW+MULT                                                        12770000
      IG=MOD(ID(I),100)                                                 12780000
      SCS(IG)=SCS(IG)+ESQ*TMUL                                          12790000
      NG(IG)=NG(IG)+MULT                                                12800000
  250 CONTINUE                                                          12810000
      GO TO 100                                                         12820000
  300 TOT=TOT/FLOAT(NW)                                                 12830000
C**** 8 PARITY GROUPS FOR TRICLINIC, MONOCLINIC AND ORTHORHOMBIC        12840001
      NN=8                                                              12850000
C**** 6 MODIFIED PARITY GROUPS FOR TETRAGONAL                           12860001
C**** 6 INDEX GROUPS IN OTHER SYSTEMS                                   12870001
      IF(KSYS.GE.4) NN=6                                                12880000
      DO 320 I=1,NN                                                     12890000
      IF(NG(I).GT.0) SCS(I)=SCS(I)/FLOAT(NG(I))                         12900000
  320 CONTINUE                                                          12910000
      WRITE(LO,330)                                                     12920000
  330 FORMAT(1H1,27X,66HAVERAGE E**2 ACCORDING TO APPROPRIATE INDEX GROU12930000
     1P BEFORE RESCALING)                                               12940000
      IF(KSYS.LE.3) WRITE(LO,335)                                       12950000
  335 FORMAT(1H0,53X,13HPARITY GROUPS/1H0,18X,3HALL,9X,3HEEE,9X,3HOEE,  12960000
     1 9X,3HEOE,9X,3HOOE,9X,3HEEO,9X,3HOEO,9X,3HEOO,9X,3HOOO)           12970000
      IF(KSYS.EQ.4) WRITE(LO,340)                                       12980000
  340 FORMAT(1H0,49X,22HMODIFIED PARITY GROUPS/1H0,18X,3HALL,9X,3HEEE,  12990000
     1 7X,7HEOE,OEE,7X,3HOOE,9X,3HEEO,7X,7HEOO,OEO,7X,3HOOO)            13000000
      IF(KSYS.LE.4) GO TO 365                                           13010000
      WRITE(LO,345)                                                     13020000
  345 FORMAT(26H0INDEX GROUPS DIVIDED ON -)                             13030000
      IF(KSYS.LE.6) WRITE(LO,350)                                       13040000
  350 FORMAT(1H+,30X,11H1) MOD(H,3),4X,11H2) MOD(K,3),4X,               13050000
     1 13H3) MOD(H+K,3),4X,11H4) MOD(L,2))                              13060000
      IF(KSYS.GE.7) WRITE(LO,355)                                       13070000
  355 FORMAT(1H+,30X,13H1) MOD(H-L,3),4X,13H2) MOD(K-L,3),4X,           13080000
     1 13H3) MOD(H-K,3),4X,15H4) MOD(H+K+L,2))                          13090000
      WRITE(LO,360)                                                     13100000
  360 FORMAT(1H0,30X,18HE - ZERO REMAINDER,4X,22HO - NON-ZERO REMAINDER/13110000
     1 1H0,18X,3HALL,9X,4HOOOE,5X,9HOOEE,OEOE,6X,4HEEEE,8X,4HOOOO,      13120000
     2 5X,9HOOEO,OEOO,6X,4HEEEO/1H ,42X,4HEOOE,32X,4HEOOO)              13130000
  365 WRITE(LO,370) TOT,(SCS(I),I=1,NN)                                 13140000
  370 FORMAT(1H ,3X,4HE**2,3X,9F12.3)                                   13150000
      WRITE(LO,380) NW,(NG(I),I=1,NN)                                   13160000
  380 FORMAT(1H ,2X,6HNUMBER,2X,9I12)                                   13170000
      TOT=1.0/TOT                                                       13180000
      IF(JUMP.EQ.1) TOT=SCAL(1)                                         13190000
      DO 400 I=1,NN                                                     13200000
      IF(NG(I).GT.0.AND.JUMP.NE.1) SCAL(I)=1.0/SCS(I)                   13210000
      IF(ISC.EQ.1) SCAL(I)=TOT                                          13220000
  400 CONTINUE                                                          13230000
      RETURN                                                            13240000
      END                                                               13250000
C**** ------------------------------------------------------------------13260001
C**** K-CURVE INTERPOLATION                                             13270001
      SUBROUTINE CURVK(ESQ,RHO,ED)                                      13280000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS13290000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        13300000
      EI=RHO*DEL                                                        13310000
      I=EI                                                              13320000
C**** FOR SMALL RHO THE CURVE IS EXTRAPOLATED FROM THE FIRST POINT      13330001
C**** USING THE LEAST SQUARES SLOPE                                     13340001
      IF(I.EQ.0) SK=EXP(SLOPE*RHO+FLGK)                                 13350000
C**** INTERPOLATION                                                     13360001
      IF(I.GT.0.AND.I.LT.50) SK=DCV(I)+(EI-FLOAT(I))*(DCV(I+1)-DCV(I))  13370000
C**** FOR LARGE RHO THE CURVE IS EXTRAPOLATED FROM THE LAST POINT       13380001
      IF(I.GE.50) SK=DCV(50)*EXP(SLOPE*(AVR(NB)-RHO))                   13390000
      ESQ=ED/SK                                                         13400000
      RETURN                                                            13410000
      END                                                               13420000
C**** ------------------------------------------------------------------13430001
C**** CALCULATE FINAL E-VALUES AND RESCALED F'S                         13440001
C**** CREATE NEW ISTAN IF REQUIRED                                      13450001
C**** OUTPUT REFLEXIONS FOR MULTAN                                      13460001
C**** PREPARE TABLES OF STATISTICS                                      13470001
      SUBROUTINE ECAL(KSYS)                                             13480000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    13490000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       13500000
     1 RHO(60),SIG(60)                                                  13510000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        13520000
      COMMON/C/FLGW(30),FLGD(30),AVR(30),DCV(50),SLOPE,FLGK,BT,SC,DEL,KS13530000
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL      13540000
      COMMON/XXX/ IX(1000),EX(1000),FX(1000)                            13550000
      DIMENSION RHR(10),NHR(10),NU(25),STL(10),INP(60),NOB(60)          13560000
C**** TABLES OF THEORETICAL DISTRIBUTIONS                               13570001
      DIMENSION AVA(10),AVC(10),AVH(10),CPH(25)                         13580000
      DATA AVA/0.886,1.0,1.329,2.0,3.323,6.0,0.736,1.0,2.0,2.415/       13590000
      DATA AVC/0.798,1.0,1.596,3.0,6.383,15.0,0.968,2.0,8.0,8.691/      13600000
      DATA AVH/0.718,1.0,1.916,4.5,12.26,37.5,1.145,3.5,26.0,26.903/    13610000
      DATA CPH/0.368,0.463,0.526,0.574,0.612,0.643,0.670,0.694,0.715,   13620000
     1 0.733,0.765,0.791,0.813,0.832,0.848,0.863,0.875,0.886,0.896,     13630000
     2 0.905,0.913,0.920,0.926,0.932,0.938/                             13640000
      DATA IOBS,IUNOBS/1H ,1HU/                                         13650000
C**** SET INITIAL VALUES                                                13660001
      DO 20 I=1,10                                                      13670000
      RHR(I)=0.0                                                        13680000
      NHR(I)=0                                                          13690000
      DO 10 J=1,5                                                       13700000
      VST(I,J)=0.0                                                      13710000
   10 CONTINUE                                                          13720000
   20 CONTINUE                                                          13730000
      DO 40 I=1,5                                                       13740000
      NST(I)=0                                                          13750000
      DO 30 J=1,25                                                      13760000
      ZT(J,I)=0.0                                                       13770000
   30 CONTINUE                                                          13780000
   40 CONTINUE                                                          13790000
      DO 50 I=1,25                                                      13800000
      NU(I)=0                                                           13810000
   50 CONTINUE                                                          13820000
      NRW=0                                                             13830000
      LIM=1000                                                          13840000
      NC=0                                                              13850000
      NS=0                                                              13860000
      NL=0                                                              13870000
      SCF=SQRT(SC)                                                      13880000
      RR=10.0/SQRT(RHOMAX)                                              13890000
      IF(LST.EQ.1) WRITE(LO,55) NREF                                    13900000
   55 FORMAT(//8H0LIST OF,I6,2X,87HREFLEXIONS. F IS ON AN ABSOLUTE SCALE13910000
     1 AND THE E-VALUES ARE SUITABLE FOR INPUT TO MULTAN/               13920000
     2 1H0,5(9H  H  K  L,5X,1HF,4X,1HE,4X))                             13930000
      IF(NPC.LT.0) REWIND ISTAN                                         13940000
      REWIND ISCRA                                                      13950000
   60 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG                          13960000
      DO 250 I=1,60                                                     13970000
      INP(I)=32896                                                      13980000
      MF=I                                                              13990000
C**** TEST FOR END OF DATA                                              14000001
      IF(FO(I).LT.0.0) GO TO 300                                        14010000
      D=SC*EXP(BT*RHO(I))                                               14020000
      MULT=ID(I)/10000                                                  14030000
      IE=(ID(I)-10000*MULT)/100                                         14040000
      IG=ID(I)-10000*MULT-100*IE                                        14050000
C**** CALCULATE E                                                       14060001
      IF(IK.NE.1) ESQ=D*ED(I)                                           14070000
      IF(IK.EQ.1) CALL CURVK(ESQ,RHO(I),ED(I))                          14080000
      ESQ=ESQ*SCAL(IG)                                                  14090000
      E=SQRT(ESQ)                                                       14100000
      ED(I)=E                                                           14110000
C**** CALCULATE RESCALED F                                              14120001
      FO(I)=FO(I)*SCF                                                   14130000
C**** PACK INDICES FOR TAPE ISTAN                                       14140001
      INP(I)=65536*LH(I)+256*(LK(I)+128)+LL(I)+128                      14150000
C**** SET OBS/UNOBS FLAG                                                14160001
      NOB(I)=IOBS                                                       14170000
      IF(SIG(I).LT.0.0) NOB(I)=IUNOBS                                   14180000
      IF(RHO(I).GT.TH) GO TO 110                                        14190000
C**** STORE REFLEXIONS FOR MULTAN                                       14200001
      IF(SIG(I).LT.0.0) GO TO 90                                        14210000
      NL=NL+1                                                           14220000
      IF(E.GT.EN) GO TO 100                                             14230000
      NL=NL-1                                                           14240000
   90 E=E+0.2*RHO(I)                                                    14250000
      IF(E.GT.ER) GO TO 110                                             14260000
      NS=NS+1                                                           14270000
  100 NC=NC+1                                                           14280000
      IX(NC)=INP(I)                                                     14290000
      EX(NC)=E                                                          14300000
      FX(NC)=FO(I)                                                      14310000
      IF(NC.NE.LIM) GO TO 110                                           14320000
      CALL SORT(EX,FX,IX,1000)                                          14330000
      IF(MZ.GT.0) ER=AMIN1(ER,EX(1001-MZ))                              14340000
      EN=AMAX1(EN,EX(MM))                                               14350000
      NC=MIN0(MM,NL)                                                    14360000
      LIM=1000-MZ                                                       14370000
C**** WORK OUT FINAL STATISTICS                                         14380001
  110 TMUL=FLOAT(MULT)                                                  14390000
C**** DISTRIBUTION OF E WITH SIN(THETA)/LAMBDA                          14400001
      N=MIN0(10,INT(1.0+RR*SQRT(RHO(I))))                               14410000
      NHR(N)=NHR(N)+MULT                                                14420000
      RHR(N)=RHR(N)+ESQ*TMUL                                            14430000
      NZR=INT(10.0*ESQ)+1                                               14440000
      IF(NZR.GT.10) NZR=10+(NZR-9)/2                                    14450000
      EE(1)=ED(I)                                                       14460000
      DO 120 J=2,6                                                      14470000
      EE(J)=EE(J-1)*ED(I)                                               14480000
  120 CONTINUE                                                          14490000
      EE(7)=ESQ-1.0                                                     14500000
      EE(8)=EE(7)*EE(7)                                                 14510000
      EE(9)=EE(8)*EE(7)                                                 14520000
      EE(10)=ABS(EE(9))                                                 14530000
      EE(7)=ABS(EE(7))                                                  14540000
      DO 130 J=1,10                                                     14550000
      EE(J)=TMUL*EE(J)                                                  14560000
  130 CONTINUE                                                          14570000
C**** ADD FUNCTIONS OF E TO APPROPRIATE ZONES                           14580001
      IND=1                                                             14590000
      J=LH(I)                                                           14600000
      K=LK(I)                                                           14610000
      L=LL(I)                                                           14620000
      CALL ADD(1)                                                       14630000
      GO TO (140,140,140,150,160,160,170,180),KSYS                      14640000
C**** TRICLINIC, MONOCLINIC AND ORTHORHOMBIC                            14650001
  140 IF(J.EQ.0) CALL ADD(3)                                            14660000
      IF(K.EQ.0) CALL ADD(4)                                            14670000
      IF(L.EQ.0) CALL ADD(5)                                            14680000
      GO TO 200                                                         14690000
C**** TETRAGONAL                                                        14700001
  150 IF(J.EQ.0.OR.K.EQ.0) CALL ADD(3)                                  14710000
      IF(IABS(J).EQ.IABS(K)) CALL ADD(4)                                14720000
      IF(L.EQ.0) CALL ADD(5)                                            14730000
      GO TO 200                                                         14740000
C**** TRIGONAL, HEXAGONAL AND RHOMBOHEDRAL INDEXED ON HEXAGONAL AXES    14750001
  160 IF(J.EQ.0.OR.K.EQ.0.OR.J+K.EQ.0) CALL ADD(3)                      14760000
      IF(J.EQ.K.OR.J+2*K.EQ.0.OR.2*J+K.EQ.0) CALL ADD(4)                14770000
      IF(L.EQ.0) CALL ADD(5)                                            14780000
      GO TO 200                                                         14790000
C**** PRIMITIVE RHOMBOHEDRAL                                            14800001
  170 IF(J.EQ.K.OR.J.EQ.L.OR.K.EQ.L) CALL ADD(3)                        14810000
      IF(L.EQ.2*K-J.OR.K.EQ.2*J-L.OR.J.EQ.2*L-K) CALL ADD(4)            14820000
      IF(J+K+L.EQ.0) CALL ADD(5)                                        14830000
      GO TO 200                                                         14840000
C**** CUBIC                                                             14850001
  180 IF(J.EQ.0.OR.K.EQ.0.OR.L.EQ.0) CALL ADD(3)                        14860000
      IF(IABS(J).EQ.IABS(K).OR.IABS(J).EQ.IABS(L).OR.IABS(K).EQ.IABS(L))14870000
     1  CALL ADD(4)                                                     14880000
C**** H,H,2H IS IN TWO PRINCIPAL ZONES BUT NOT ON A PRINCIPAL AXIS      14890001
      IF(IND.EQ.4) IND=0                                                14900000
      IF(IABS(L).EQ.IABS(J+K).OR.IABS(K).EQ.IABS(J+L).OR.IABS(J).       14910000
     1 EQ.IABS(K+L)) CALL ADD(5)                                        14920000
C**** REFLEXIONS NOT BELONGING TO PRINCIPAL ZONES                       14930001
  200 IF(IND.EQ.1) CALL ADD(2)                                          14940000
C**** DISTRIBUTION OF E FOR COMPLETE DATA                               14950001
      NET=MIN0(25,INT(10.0*ED(I)))                                      14960000
      IF(NET.EQ.0) GO TO 220                                            14970000
      NU(NET)=NU(NET)+1                                                 14980000
  220 NRW=NRW+MULT                                                      14990000
  250 CONTINUE                                                          15000000
C**** CREATE (OR REWRITE) ISTAN OP KANAAL 15 I.P.V. KANAAL 20           15010001
  300 IF(NPC.LT.0) WRITE(15) INP,FO,ED,SIG                              15020000
      IF(FO(MF).LT.0.0) MF=MF-1                                         15030000
C**** LIST REFLEXIONS IF REQUIRED                                       15040001
      IF(LST.EQ.1.AND.MF.NE.0) WRITE(LO,305) (LH(K),LK(K),LL(K),FO(K),  15050000
     1 ED(K),NOB(K),K=1,MF)                                             15060000
C**** FORMAT FOR REFLEXION LIST - A WIDER LINEPRINTER MAY ALLOW MORE    15070001
C**** REFLEXIONS TO BE OUTPUT ON ONE LINE - THUS SAVING PAPER           15080001
  305 FORMAT(5(1H ,3I3,F7.1,F5.2,1X,A1))                                15090000
C**** TEST FOR END OF DATA                                              15100001
      IF(MF.EQ.60) GO TO 60                                             15110000
C**** OUTPUT STATISTICS                                                 15120001
      RR=1.0/RR                                                         15130000
      DO 320 I=1,10                                                     15140000
      STL(I)=RR*FLOAT(I)                                                15150000
      IF(NHR(I).GT.0) RHR(I)=RHR(I)/FLOAT(NHR(I))                       15160000
      DO 310 J=1,5                                                      15170000
      IF(NST(J).GT.0) VST(I,J)=VST(I,J)/FLOAT(NST(J))                   15180000
  310 CONTINUE                                                          15190000
  320 CONTINUE                                                          15200000
      WRITE(LO,330) STL,RHR,NHR                                         15210000
  330 FORMAT(///1H0,52X,16HFINAL STATISTICS//1H ,38X,                   15220000
     1 43HDISTRIBUTION OF E**2 WITH SIN(THETA)/LAMBDA/10H SINTH/LAM,    15230000
     2 10F10.4/1H ,3X,4HE**2,2X,10F10.4/1H ,2X,6HNUMBER,10I10)          15240000
      WRITE(LO,340)                                                     15250000
  340 FORMAT(//1H0,53X,14HAVERAGE VALUES)                               15260000
      WRITE(LO,350)                                                     15270000
  350 FORMAT(1H0,45X,12HEXPERIMENTAL,39X,11HTHEORETICAL/1H ,23X,        15280000
     1 8HALL DATA,7X,3HHKL,44X,8HACENTRIC,5X,7HCENTRIC,                 15290000
     2 2X,12HHYPERCENTRIC)                                              15300000
      WRITE(LO,360)                                                     15310000
  360 FORMAT(1H+,4X,7HAVERAGE)                                          15320000
C**** CAPTION ACCORDING TO CRYSTAL SYSTEM                               15330001
      IF(KSYS.NE.7) WRITE(LO,370)                                       15340000
  370 FORMAT(1H+,50X,3H0KL)                                             15350000
      IF(KSYS.EQ.7) WRITE(LO,380)                                       15360000
  380 FORMAT(1H+,47X,8HH,K,2K-H)                                        15370000
      IF(KSYS.LE.3) WRITE(LO,390)                                       15380000
  390 FORMAT(1H+,62X,3HH0L)                                             15390000
      IF(KSYS.GE.4) WRITE(LO,400)                                       15400000
  400 FORMAT(1H+,62X,3HHHL)                                             15410000
      IF(KSYS.LE.6) WRITE(LO,410)                                       15420000
  410 FORMAT(1H+,74X,3HHK0)                                             15430000
      IF(KSYS.GE.7) WRITE(LO,420)                                       15440000
  420 FORMAT(1H+,71X,8HH,K,-H-K)                                        15450000
      WRITE(LO,430) ((VST(I,J),J=1,5),AVA(I),AVC(I),AVH(I),I=1,10)      15460000
  430 FORMAT(1H ,5X,6HMOD(E),7X,5F12.3,2X,3F12.3/                       15470000
     1 1H ,6X,4HE**2,8X,5F12.3,2X,3F12.3/                               15480000
     2 1H ,6X,4HE**3,8X,5F12.3,2X,3F12.3/                               15490000
     3 1H ,6X,4HE**4,8X,5F12.3,2X,3F12.3/                               15500000
     4 1H ,6X,4HE**5,8X,5F12.3,2X,3F12.3/                               15510000
     5 1H ,6X,4HE**6,8X,5F12.3,2X,3F12.3/                               15520000
     6 1H ,2X,11HMOD(E**2-1),5X,5F12.3,2X,3F12.3/                       15530000
     7 1H ,2X,11H(E**2-1)**2,5X,5F12.3,2X,3F12.3/                       15540000
     8 1H ,2X,11H(E**2-1)**3,5X,5F12.3,2X,3F12.3/                       15550000
     9 1H ,16H(MOD(E**2-1))**3,2X,5F12.3,2X,3F12.3)                     15560000
      WRITE(LO,440) NST                                                 15570000
  440 FORMAT(21H0WEIGHTED SAMPLE SIZE,I10,4I12)                         15580000
      WRITE(LO,450)                                                     15590000
  450 FORMAT(//1H0,40X,40HN(Z) CUMULATIVE PROBABILITY DISTRIBUTION)     15600000
      WRITE(LO,350)                                                     15610000
      WRITE(LO,460)                                                     15620000
  460 FORMAT(1H+,5X,1HZ)                                                15630000
C**** CAPTION ACCORDING TO CRYSTAL SYSTEM                               15640001
      IF(KSYS.NE.7) WRITE(LO,370)                                       15650000
      IF(KSYS.EQ.7) WRITE(LO,380)                                       15660000
      IF(KSYS.LE.3) WRITE(LO,390)                                       15670000
      IF(KSYS.GE.4) WRITE(LO,400)                                       15680000
      IF(KSYS.LE.6) WRITE(LO,410)                                       15690000
      IF(KSYS.GE.7) WRITE(LO,420)                                       15700000
      DO 500 I=1,25                                                     15710000
      DO 470 J=1,5                                                      15720000
      IF(NST(J).GT.0) ZT(I,J)=ZT(I,J)/FLOAT(NST(J))                     15730000
      IF(I.NE.1) ZT(I,J)=ZT(I,J)+ZT(I-1,J)                              15740000
  470 CONTINUE                                                          15750000
C**** THEORETICAL DISTRIBUTIONS                                         15760001
      ZZ=0.1*FLOAT(I)                                                   15770000
      IF(I.GT.10) ZZ=2.0*ZZ-1.0                                         15780000
C**** ACENTRIC                                                          15790001
      CPA=1.0-EXP(-ZZ)                                                  15800000
C**** CENTRIC                                                           15810001
      XX=SQRT(0.5*ZZ)                                                   15820000
      T=1.0/(1.0+0.47047*XX)                                            15830000
      CPC=1.0-((0.74786*T-0.09588)*T+0.34802)*T*EXP(-0.5*ZZ)            15840000
      WRITE(LO,480) ZZ,(ZT(I,J),J=1,5),CPA,CPC,CPH(I)                   15850000
  480 FORMAT(1H ,F7.1,11X,5F12.3,2X,3F12.3)                             15860000
  500 CONTINUE                                                          15870000
      WRITE(LO,440) NST                                                 15880000
      DO 510 I=1,24                                                     15890000
      J=25-I                                                            15900000
      NU(J)=NU(J)+NU(J+1)                                               15910000
  510 CONTINUE                                                          15920000
      WRITE(LO,520)                                                     15930000
  520 FORMAT(/1H0,38X,44HDISTRIBUTION OF E - NUMBER OF E'S .GT. LIMIT)  15940000
      DO 540 I=1,25                                                     15950000
      AVR(I)=0.1*FLOAT(I)                                               15960000
  540 CONTINUE                                                          15970000
      WRITE(LO,560) (AVR(I),I=7,25),(NU(I),I=7,25)                      15980000
  560 FORMAT(1H0,2X,3HE  ,19F6.1/1H ,1X,4HNO. ,19I6)                    15990000
C**** OUTPUT REFLEXIONS FOR MULTAN                                      16000001
      MR=1000                                                           16010000
      IF(LIM.EQ.1000) MR=NC                                             16020000
      CALL SORT(EX,FX,IX,MR)                                            16030000
      MM=MIN0(MM,NL)                                                    16040000
      WRITE(LO,580) MM                                                  16050000
  580 FORMAT(///1H ,I6,41H  LARGEST E-VALUES WRITTEN TO OUTPUT FILE)    16060000
      CALL OUTPUT(EX,FX,IX,0,MM)                                        16070000
      MZ=MIN0(MZ,NS)                                                    16080000
      MS=MR-MZ                                                          16090000
      WRITE(LO,600) MZ                                                  16100000
  600 FORMAT(1H0,I6,42H  SMALLEST E-VALUES WRITTEN TO OUTPUT FILE)      16110000
      CALL OUTPUT(EX,FX,IX,MS,MR)                                       16120000
  630 RETURN                                                            16130000
      END                                                               16140000
C**** ------------------------------------------------------------------16150001
C**** SUMS FOR REFLEXION IN ZONE N                                      16160001
      SUBROUTINE ADD(N)                                                 16170000
      COMMON/ST/VST(10,5),NST(5),ZT(25,5),EE(10),MULT,IND,NZR,TMUL      16180000
      IS=1                                                              16190000
      NT=N                                                              16200000
      IF(N.LE.2.OR.IND.LE.1) GO TO 20                                   16210000
C**** REFLEXION IS ON PRINCIPAL AXIS - THEREFORE IGNORE IT              16220001
      NT=IND                                                            16230000
      IS=-1                                                             16240000
   20 S=FLOAT(IS)                                                       16250000
      DO 30 I=1,10                                                      16260000
      VST(I,NT)=VST(I,NT)+S*EE(I)                                       16270000
   30 CONTINUE                                                          16280000
      NST(NT)=NST(NT)+IS*MULT                                           16290000
      IF(NZR.LE.25) ZT(NZR,NT)=ZT(NZR,NT)+S*TMUL                        16300000
      IND=N                                                             16310000
      RETURN                                                            16320000
      END                                                               16330000
C**** ------------------------------------------------------------------16340001
C**** SORT ON A                                                         16350001
      SUBROUTINE SORT(A,B,IX,N)                                         16360000
      DIMENSION A(N),B(N),IX(N)                                         16370000
      INT=2                                                             16380000
   10 INT=2*INT                                                         16390000
      IF(INT.LT.N) GO TO 10                                             16400000
      INT=MIN0(N,(3*INT)/4-1)                                           16410000
   20 INT=INT/2                                                         16420000
      IFIN=N-INT                                                        16430000
      DO 70 II=1,IFIN                                                   16440000
      I=II                                                              16450000
      J=I+INT                                                           16460000
      IF(A(I).GE.A(J)) GO TO 70                                         16470000
      T=A(J)                                                            16480000
      X=B(J)                                                            16490000
      L=IX(J)                                                           16500000
   40 A(J)=A(I)                                                         16510000
      B(J)=B(I)                                                         16520000
      IX(J)=IX(I)                                                       16530000
      J=I                                                               16540000
      I=I-INT                                                           16550000
      IF(I.LE.0) GO TO 60                                               16560000
      IF(A(I).LT.T) GO TO 40                                            16570000
   60 A(J)=T                                                            16580000
      B(J)=X                                                            16590000
      IX(J)=L                                                           16600000
   70 CONTINUE                                                          16610000
      IF(INT.GT.1) GO TO 20                                             16620000
      RETURN                                                            16630000
      END                                                               16640000
C**** ------------------------------------------------------------------16650001
C**** PRINT AND OUTPUT TO FILE FOR REFLEXIONS TO BE USED IN MULTAN      16660001
      SUBROUTINE OUTPUT(EX,FX,IX,N,M)                                   16670000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    16680000
      DIMENSION EX(1000),FX(1000),IX(1000)                              16690000
      DIMENSION J(6),K(6),L(6),E(6),KODE(6)                             16700000
      IF(N.EQ.M) GO TO 60                                               16710000
      WRITE(LO,10)                                                      16720000
   10 FORMAT(6(1X,4HCODE,9H  H  K  L,3X,1HE,2X))                        16730000
      NA=N+1                                                            16740000
      KK=0                                                              16750000
      DO 50 JJ=NA,M                                                     16760000
      I=JJ                                                              16770000
      IF(N.NE.0) I=M-JJ+NA                                              16780000
      KK=KK+1                                                           16790000
      IND=IX(I)                                                         16800000
      J(KK)=IND/65536                                                   16810000
      IF(IND.LT.0) J(KK)=J(KK)-1                                        16820000
      IND=IND-65536*J(KK)                                               16830000
      K(KK)=IND/256                                                     16840000
      L(KK)=IND-256*K(KK)-128                                           16850000
      K(KK)=K(KK)-128                                                   16860000
      WRITE(LNTA,20) J(KK),K(KK),L(KK),EX(I)                            16870000
   20 FORMAT(3I5,F10.3)                                                 16880000
      E(KK)=EX(I)                                                       16890000
      KODE(KK)=JJ-N                                                     16900000
      IF(KK.NE.6) GO TO 50                                              16910000
      WRITE(LO,30) (KODE(II),J(II),K(II),L(II),E(II),II=1,6)            16920000
   30 FORMAT(6(I5,3I3,F6.3))                                            16930000
      KK=0                                                              16940000
   50 CONTINUE                                                          16950000
      IF(KK.EQ.0) GO TO 60                                              16960000
      WRITE(LO,30) (KODE(II),J(II),K(II),L(II),E(II),II=1,KK)           16970000
   60 KK=0                                                              16980000
      D=-1.0                                                            16990000
      WRITE(LNTA,20) KK,KK,KK,D                                         17000000
      RETURN                                                            17010000
      END                                                               17020000
C**** ------------------------------------------------------------------17030001
C**** PHASE CALCULATION FOR WEIGHTED KARLE RECYCLING                    17040001
      SUBROUTINE RECYC(NS,NF,BT)                                        17050000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    17060000
      COMMON/SYM/IS(2,3,24),TS(3,24),NSYM,PTS,KSYS,ICENT,LATT,LATB      17070000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       17080000
     1 RHO(60),SIG(60)                                                  17090000
      COMMON/SF/AL(8),AS(8),BL(8),BS(8),CL(8),NW(8),NO(8),NK,NAT,F(9),
     1 CS(8),DL(8),DS(8),EL(8)
      COMMON/GP/NINF(10),NAG(10),X(200),Y(200),Z(200),NZ(200)           17110000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        17120000
      COMMON/XXX/IX(1000),EX(1000),FX(1000)                             17130000
      DIMENSION I1(3),I2(3),IFAZ(500)                                   17140000
C**** I1/I0 (BESSEL FUNCTIONS)                                          17150001
      VEC(U)=U*(U+0.4807)/((U+0.8636)*U+1.3943)                         17160000
C**** CALCULATE PKARL (RATIO OF KNOWN TO COMPLETE STRUCTURE)            17170001
      KARL=0                                                            17180000
      DO 150 I=NS,NF                                                    17190000
      K=NZ(I)                                                           17200000
      KARL=KARL+NO(K)                                                   17210000
  150 CONTINUE                                                          17220000
      KTOT=0                                                            17230000
      DO 160 I=1,NK                                                     17240000
      KTOT=KTOT+NW(I)*NO(I)                                             17250000
  160 CONTINUE                                                          17260000
      PKARL=FLOAT(KARL*NSYM*(ICENT+1))*PTS/FLOAT(KTOT)                  17270000
      IF(PKARL.LT.0.25) PKARL=0.25                                      17280000
      IF(PKARL.GT.0.60) PKARL=0.60                                      17290000
      WRITE(LO,180) ITLE,PKARL                                          17300000
  180 FORMAT (//1X,119(1H+)//1X,20A4,2X,37HPHASE CALCULATION FOR KARLE R17310000
     1ECYCLING//38X,39HRATIO OF KNOWN TO COMPLETE STRUCTURE IS,F6.2)    17320000
C**** CALCULATE PHASES AND SELECT REFLEXIONS FOR INPUT TO MULTAN        17330001
      REWIND ISCRA                                                      17340000
      SUMF=0.0                                                          17350000
      SUMC=0.0                                                          17360000
  200 READ(ISCRA) LH,LK,LL,FO,ID,EW,ED,RHO,SIG                          17370000
      DO 300 I=1,60                                                     17380000
      IF(FO(I).LT.0.0) GO TO 310                                        17390000
      IP=65536*LH(I)+256*(LK(I)+128)+LL(I)+128                          17400000
      DO 210 IM=1,MM                                                    17410000
      IF(IX(IM).EQ.IP) GO TO 220                                        17420000
  210 CONTINUE                                                          17430000
      GO TO 300                                                         17440000
  220 SUMF=SUMF+FX(IM)                                                  17450000
      I1(1)=LH(I)                                                       17460000
      I1(2)=LK(I)                                                       17470000
      I1(3)=LL(I)                                                       17480000
      REL=0.0                                                           17490000
      RIM=0.0                                                           17500000
      IENT=0                                                            17510000
      DO 260 J=1,NSYM                                                   17520000
      T=1000.0                                                          17530000
      DO 230 L=1,3                                                      17540000
      T=T+FLOAT(I1(L))*TS(L,J)                                          17550000
      I2(L)=0                                                           17560000
  230 CONTINUE                                                          17570000
      DO 250 L=1,3                                                      17580000
      DO 240 K=1,2                                                      17590000
      M=IABS(IS(K,L,J))                                                 17600000
      IF(M.GT.0) I2(M)=I2(M)+I1(L)*ISIGN(1,IS(K,L,J))                   17610000
  240 CONTINUE                                                          17620000
  250 CONTINUE                                                          17630000
      CALL SFAC(NS,NF,I2,T,RHO(I),A,B,IENT)                             17640000
      IENT=1                                                            17650000
      REL=REL+A                                                         17660000
      IF(ICENT.EQ.0) RIM=RIM+B                                          17670000
      IF(ICENT.EQ.1) REL=REL+A                                          17680000
  260 CONTINUE                                                          17690000
      E=EX(IM)                                                          17700000
      EX(IM)=PTS*SQRT((REL*REL+RIM*RIM)*EXP(-BT*RHO(I)))                17710000
      SUMC=SUMC+EX(IM)                                                  17720000
      IFAZ(IM)=0                                                        17730000
C**** CALCULATE SIM WEIGHT                                              17740001
      XKAP=2.0*E*E*EX(IM)/((1.0-PKARL)*FX(IM))                          17750000
      IF(XKAP.GT.4.0) GO TO 280                                         17760000
      IF(XKAP.LT.2.4.OR.E.LT.1.5.OR.EX(IM).LT.PKARL*FX(IM)) GO TO 300   17770000
  280 IF (ICENT.EQ.0) EX(IM+500) = VEC(XKAP)                            17780000
      IF (ICENT.EQ.1) EX(IM+500) = TANH(XKAP/2.0)                       17790000
      FAZE=(180.0/PI)*ATAN2(RIM,REL)+360.0                              17800000
      IFAZ(IM)=MOD(INT(FAZE+0.5),360)                                   17810000
      IF(IFAZ(IM).EQ.0) IFAZ(IM)=360                                    17820000
  300 CONTINUE                                                          17830000
      GO TO 200                                                         17840000
  310 MARK=-1                                                           17850000
      SCALE=SUMC/SUMF                                                   17860000
      RS=0.0                                                            17870000
      NREC=0                                                            17880000
      DO 350 I=1,MM                                                     17890000
      RS=RS+ABS(SCALE*FX(I)-EX(I))                                      17900000
      IF(IFAZ(I).LE.0) GO TO 350                                        17910000
      NREC=NREC+1                                                       17920000
      IX(NREC)=I                                                        17930000
      IX(NREC+500)=IFAZ(I)                                              17940000
      FX(NREC+500)=EX(I+500)                                            17950000
  350 CONTINUE                                                          17960000
      RS=100.0*RS/SUMC                                                  17970000
      IF(NREC.GT.250) NREC=250                                          17980000
      WRITE(LO,360) SCALE,RS,NREC                                       17990000
  360 FORMAT (/35X,7HSCALE =,F7.3,19X,10HR-FACTOR =,F7.2//38X,          18000000
     1 39HNUMBER OF REFLEXIONS PASSED TO MULTAN =,I5//1X,119(1H+))      18010000
      WRITE(LREC,370) ITLE,NREC                                         18020000
  370 FORMAT(20A4/7HPHASES ,I4)                                         18030000
      WRITE(LREC,380) (IX(I),I=1,NREC)                                  18040000
  380 FORMAT(20I4)                                                      18050000
      WRITE(LREC,380) (MARK,I=1,NREC)                                   18060000
      WRITE(LREC,390) (FX(I+500),I=1,NREC)                              18070000
  390 FORMAT(20F4.2)                                                    18080000
      WRITE(LREC,380) (IX(I+500),I=1,NREC),MARK                         18090000
      RETURN                                                            18100000
      END                                                               18110000
C**** ------------------------------------------------------------------18120001
C**** R-FACTOR FOR COMPLETE DATA                                        18130001
      SUBROUTINE RFAC                                                   18140000
      COMMON/UNIT/LN,LO,ISTAN,ISCRA,LNTA,LREC,PI,ITLE(20),LST,IK,NPC    18150000
      COMMON/RE/LH(60),LK(60),LL(60),FO(60),ID(60),ED(60),EW(60),       18160000
     1 RHO(60),SIG(60)                                                  18170000
      COMMON/RC/P(6),CX(9),NREF,NB,RHOMAX,MM,EN,MZ,ER,SCAL(8),TH        18180000
      SCALE=EN/ER                                                       18190000
      R=0.0                                                             18200000
      REWIND ISCRA                                                      18210000
      READ(ISCRA)                                                       18220000
      READ(ISCRA)                                                       18230000
  100 READ(ISCRA) LH,LK,LL,EW,ED,FO,SIG                                 18240000
      DO 200 I=1,60                                                     18250000
      IF(FO(I).LT.0.0) GO TO 250                                        18260000
      R=R+ABS(SIG(I)-SCALE*FO(I))                                       18270000
  200 CONTINUE                                                          18280000
      GO TO 100                                                         18290000
  250 R=100.0*R/EN                                                      18300000
      WRITE(LO,280) R,NREF                                              18310000
  280 FORMAT(1H0,39X,10HR-FACTOR =,F7.2,3X,3HFOR,I6,2X,10HREFLEXIONS)   18320000
      RETURN                                                            18330000
      END                                                               18340000

